SystemOrganization addCategory: #Marea!
SystemOrganization addCategory: #'Marea-Collections'!
SystemOrganization addCategory: #'Marea-Swapping'!
SystemOrganization addCategory: #'Marea-Swapping-Tests'!
SystemOrganization addCategory: #'Marea-Proxies'!
SystemOrganization addCategory: #'Marea-Serializers'!
SystemOrganization addCategory: #'Marea-Logging'!

FLPrimitiveCluster subclass: #FLProxyCluster
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Marea-Serializers'!

!FLProxyCluster class methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 7/18/2011 12:04'!
id

	^102! !

!FLProxyCluster methodsFor: 'serialize/materialize' stamp: 'MarianoMartinezPeck 10/4/2011 15:32'!
add: anObject traceWith: anAnalyzer
	"Add an object to the cluster. We know the object doesn't have references."

	objects add: anObject! !

!FLProxyCluster methodsFor: 'serialize/materialize' stamp: 'MarianoMartinezPeck 12/13/2011 16:32'!
materializeFrom: aReadStream
	
	^ (Smalltalk at: aReadStream nextString asSymbol)
		newProxy mareaProxyID: (aReadStream int32)! !

!FLProxyCluster methodsFor: 'serialize/materialize' stamp: 'MarianoMartinezPeck 10/4/2011 15:31'!
newSerializingCollection
	"Answer a collection for the objects that correspond to this cluster."

	^ProxiesIdentitySet new! !

!FLProxyCluster methodsFor: 'serialize/materialize' stamp: 'MarianoMartinezPeck 10/4/2011 15:31'!
registerIndexesOn: aDictionary

	self flag: #todo. "Converting objects collection here in this method is a bit confusing. This is because since this cluster is for primitives, they do not have pointers to other objects. Hence, instead of storing them in a IdentitySet we can use an OrderedCollection and then just convert them at the end. For more details see FLPrimitiveCluster >> #add: anObject traceWith: anAnalyzer"
	self objects do: [ :instance | aDictionary at: instance put: aDictionary size + 1 ].! !

!FLProxyCluster methodsFor: 'serialize/materialize' stamp: 'MarianoMartinezPeck 12/13/2011 16:31'!
serialize: aProxy on: aWriteStream
	
	aWriteStream nextStringPut: aProxy mareaClass name.
	aWriteStream int32: aProxy mareaProxyID ! !

!FLSerializer methodsFor: '*Marea' stamp: 'MarianoMartinezPeck 10/4/2011 17:32'!
mareaSerialization

	^ serializationFactory := [:anObject :aStream | 
		(FLMareaSerialization 
			root: anObject 
			on: aStream
			analyzer: self analyzer)
			run;
			yourself ]! !

FLMapper subclass: #FLProxyMapper
	instanceVariableNames: 'mareaProxyCluster'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Marea-Serializers'!

!FLProxyMapper methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/3/2011 15:12'!
accepts: anObject

	^ anObject mareaIsProxy! !

!FLProxyMapper methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/3/2011 15:13'!
clusterFor: anObject

	^ mareaProxyCluster
! !

!FLProxyMapper methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/3/2011 15:53'!
initialize

	mareaProxyCluster := FLProxyCluster new.
! !

FLClassPoolAssociationMapper subclass: #FLMareaClassPoolAssociationMapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Marea-Serializers'!

!FLMareaClassPoolAssociationMapper methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 12/12/2011 11:40'!
initializeClassPoolsBindings

	classPoolBindings := IdentityDictionary new.
	Smalltalk mareaAllClassesAndTraitsWithoutProxiesDo: [ :aClass | 
				aClass classPool associationsDo: [ :aBinding | 
					classPoolBindings at: aBinding put: aClass ] ].! !

FLGlobalBehaviorMapper subclass: #FLMareaGlobalBehaviorMapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Marea-Serializers'!

!FLMareaGlobalBehaviorMapper methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 12/12/2011 11:40'!
initializeGlobalBehaviors

	globalBehaviors := ProxiesIdentitySet new.
	Smalltalk globals mareaAllClassesAndTraitsWithoutProxiesDo: [:each | globalBehaviors add: each].
! !

!SmallInteger methodsFor: '*Marea' stamp: 'MarianoMartinezPeck 10/4/2011 15:40'!
mareaIdentityHash

	^self hashMultiply! !

!CompiledMethod class methodsFor: '*Marea' stamp: 'MarianoMartinezPeck 12/1/2011 12:52'!
receiver: aReceirver withArgs: argArray executeMethod: compiledMethod
	"Execute compiledMethod against the receiver and args in argArray"

	<primitive: 188>
	self primitiveFailed! !

!CompiledMethod methodsFor: '*Marea' stamp: 'MarianoMartinezPeck 11/17/2010 21:58'!
mareaPrintString 
	^ self methodClass asString, '>>', self selector.! !

FLAnalyzer subclass: #FLMareaAnalyzer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Marea-Serializers'!

!FLMareaAnalyzer methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 12/12/2011 11:35'!
allGlobalMappers

	^ (Array with: FLGlobalAssociationMapper with: FLMareaClassPoolAssociationMapper with: FLGlobalMapper with: FLMareaGlobalBehaviorMapper) 
		collect: [:aMapperClass | aMapperClass new internalObjects: internalClasses; yourself ]! !

!FLMareaAnalyzer methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/3/2011 16:10'!
mappers

	| mappers |
	mappers := OrderedCollection new.
	mappers add: FLProxyMapper new.
	mappers addAll: self pluggableSubstitutionMappers.
	mappers addAll: self globalMappers.
	mappers add: self defaultMapper.
	^mappers! !

!Behavior methodsFor: '*Marea' stamp: 'MarianoMartinezPeck 3/14/2011 22:54'!
hasAllMethodsAsProxies
	^ self allMethods allSatisfy: [:aMethod | aMethod mareaIsProxy  ].
	! !

!Behavior methodsFor: '*Marea' stamp: 'MarianoMartinezPeck 12/8/2011 21:32'!
mareaFindClassWithNilMethodDictInHierarchy
	methodDict isNil 
		ifTrue: [ ^ self ]
		ifFalse: [ ^ CompiledMethod receiver: superclass withArgs: #() executeMethod: (Behavior >> #mareaFindClassWithNilMethodDictInHierarchy) ]! !

!Behavior methodsFor: '*Marea' stamp: 'MarianoMartinezPeck 3/13/2011 22:50'!
methodDict
	methodDict == nil ifTrue: ["self manageMDFault" ^ self emptyMethodDictionary  ].
	^ methodDict! !

!MethodReference methodsFor: '*Marea' stamp: 'MarianoMartinezPeck 11/28/2010 20:21'!
mareaPrintString
	^ self actualClass name, ' >> #', methodSymbol! !

!ProtoObject methodsFor: '*Marea' stamp: 'MarianoMartinezPeck 10/20/2010 11:33'!
class
	"Primitive. Answer the object which is the receiver's class. Essential. See 
	Object documentation whatIsAPrimitive."

	<primitive: 111>
	self primitiveFailed! !

!ProtoObject methodsFor: '*Marea' stamp: 'MarianoMartinezPeck 11/17/2010 19:53'!
mareaClass
	"Primitive. Answer the object which is the receiver's class. Essential. See 
	Object documentation whatIsAPrimitive."

	<primitive: 111>
	self primitiveFailed! !

!ProtoObject methodsFor: '*Marea' stamp: 'MarianoMartinezPeck 10/4/2011 15:17'!
mareaIdentityHash
	"Answer a SmallInteger whose value is related to the receiver's identity.
	This method must not be overridden, except by SmallInteger.
	
	Do not override."

	^ self basicIdentityHash bitShift: 18! !

!ProtoObject methodsFor: '*Marea' stamp: 'MarianoMartinezPeck 10/22/2010 17:32'!
mareaLog: anObject
	MareaLogger logger log: anObject.! !

!SystemDictionary methodsFor: '*Marea' stamp: 'MarianoMartinezPeck 12/14/2011 00:29'!
mareaAllClassesAndTraitsWithoutProxiesDo: aBlock
	"Evaluate the argument, aBlock, for each class and trait in the system."
	
	^self classAndTraitNames do: [:each | 
		(Smalltalk at: each) mareaClass mareaIsProxy ifFalse:
		[aBlock value: (self at: each)] ]
	
	
! !

Error subclass: #CannotProxifyCompactClasses
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Marea-Proxies'!

Error subclass: #ProxyIsNotInstalled
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Marea-Proxies'!

FLSerialization subclass: #FLMareaSerialization
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Marea-Serializers'!

!FLMareaSerialization methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/15/2011 22:32'!
analysisStep

	| anAnalysis |
	anAnalysis := analyzer analysisFor: root.
	clusters := anAnalysis clusterization clusters.
	objectCount := anAnalysis clusterization objectCount.
	objectsIndexes := ProxiesIdentityDictionary new: objectCount.
	indexCluster := FLSmallIntegerCluster for: objectCount.! !

TestCase subclass: #ClutterCollector
	instanceVariableNames: 'initialProxiesCount initialCMCount initialMDCount initialMetaclassesCount initialMemory finalProxiesCount finalCMCount finalMDCount finalMetaclassesCount finalMemory diffProxiesCount diffCMCount diffMDCount diffMetaclassesCount diffMemory classesNotToSwap'
	classVariableNames: 'Logger ProxyClass'
	poolDictionaries: ''
	category: 'Marea-Swapping'!

!ClutterCollector class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 12/13/2011 10:05'!
proxyClass
	^ ProxyClass ! !

!ClutterCollector class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 12/13/2011 10:05'!
proxyClass: aProxyClass
	ProxyClass := aProxyClass.! !

!ClutterCollector methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 12/14/2011 00:59'!
canClassBeSwapped: aClass
	
	aClass subclasses isEmpty ifFalse: [^ false].
	(aClass inheritsFrom: SharedPool) ifTrue: [^ false].
	(self classesNotToSwap includes: aClass) ifTrue: [^ false].
	^ true! !

!ClutterCollector methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 12/13/2011 12:18'!
classesNotToSwap
	classesNotToSwap isNil ifTrue: [classesNotToSwap :=  self listOfClassesNotToSwap ].
	^ classesNotToSwap! !

!ClutterCollector methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 12/13/2011 12:50'!
classesToSwapOutOfPackagesIncludingSubstrings: includingStrings excludingSubstrings: excludingStrings 

	| classesToSwap |
	classesToSwap := IdentitySet new.
	(PackageInfo allPackages select: [:each| 
		(includingStrings anySatisfy:  [:aString  | (each packageName includesSubString: aString)]) and: 
		[(excludingStrings noneSatisfy:  [:aString  | (each packageName includesSubString: aString)])]   
		] ) 
	do: [:aPackage |
		classesToSwap addAll: (aPackage classes select: [:each | self canClassBeSwapped: each ]  )
		].
	^ classesToSwap.! !

!ClutterCollector methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 12/13/2011 09:59'!
clean
	MCMethodDefinition shutDown.
	Symbol compactSymbolTable.
	3 timesRepeat: [Smalltalk garbageCollect].
	! !

!ClutterCollector methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 12/13/2011 12:54'!
initializeAndClean

	MareaLogger changeToFileLogger.
	self proxyClass: RegularObjectProxy.
	ObjectGraphSwapper resetGlobalTable.
	ObjectGraphSwapper resetGraphID.
	ObjectGraphSwapper resetSharedProxiesTable.  
	ObjectGraphSwapper proxyCreator: self proxyClass.
	Logger := nil.
	(FileDirectory default fileNamesMatching: '*.swap*') 
		do: [ :aFile | FileDirectory default deleteFileNamed: aFile ].
	FileDirectory default deleteFileNamed:  'MareaDebug.log'.
	FileDirectory default deleteFileNamed:  'Proxies.txt'.
	FileDirectory default deleteFileNamed:  'Swapper.txt'.
	FileDirectory default deleteFileNamed:  'crash.dmp'.
	MareaLogger createAndSetLogger.
	self clean.
! !

!ClutterCollector methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 12/13/2011 12:18'!
listOfClassesNotToSwap

	| tooDangerousClasses coreClasses protoObjectSubclasses classesSpecialArray veryUsedClasses allClasses debuggingClasses nilSubclasses |

	"This are classes that are known as too dangerous."
	tooDangerousClasses := OrderedCollection new.
	(ClassBuilder new tooDangerousClasses) 
		do: [:each | Smalltalk globals at: each 
			ifPresent: [:present | tooDangerousClasses add: (Smalltalk at: each) ] 
			ifAbsent: []].
	
	"These classes because they are too core and used by the code to swapout itseld"
	coreClasses :=  {Array. Object. ProtoObject. Class. Message. MethodDictionary. CompiledMethod}. 

	"Subclasses of ProtoObject because they do not implement some methods that Object does and that are used by the swapping stuff."
	protoObjectSubclasses := ProtoObject subclasses.
	
	"These classes cannot be swapped because they are used by the VM"
	classesSpecialArray := Smalltalk specialObjectsArray select: [ :each | each isBehavior ].
	
	"These classes cannot be swapped because they install the segment (they are used) even before the segment can be written into a file"
	veryUsedClasses := { Cursor. CursorWithMask. EncodedCharSet.}.
	
	"Classes that are usually needed to debug and they help us to analyze problems"
	debuggingClasses := { DEVToolSet. }.
	
	"nil subclasses cannot be swapped out because since they don't subclass ProtoObject they may not even implement doesNotUnderstand:.
	For example, if we swap a CompiledMethod of PseudoContext, and then we try to load it back, the VM will crash with the error Recursive not understood error encountered. '"
	nilSubclasses := nil subclasses.
	
	allClasses := coreClasses, protoObjectSubclasses, classesSpecialArray, veryUsedClasses, tooDangerousClasses, debuggingClasses, nilSubclasses.
	
	^ allClasses asIdentitySet ! !

!ClutterCollector methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 12/13/2011 10:19'!
log: aString
	self logger log: aString ! !

!ClutterCollector methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 12/13/2011 11:37'!
logDifferences

	diffProxiesCount :=  initialProxiesCount - finalProxiesCount.
	diffCMCount := initialCMCount - finalCMCount.
	diffMDCount := initialMDCount - finalMDCount.
	diffMetaclassesCount := initialMetaclassesCount - finalMetaclassesCount.
	diffMemory := initialMemory - finalMemory.
	
	self log: '------------------------------------------------------------------'.
	self log: 'Results (difference between initial and final state) of the swapping: '.
	self log: 'CompiledMethods: ', diffCMCount asString.
	self log: 'MethodDictionaries: ', diffMDCount asString.
	self log: 'Metaclasses: ', diffMetaclassesCount asString.
	self log: 'Memory: ',  diffMemory asString.
	
	
	
	! !

!ClutterCollector methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 12/13/2011 11:28'!
logFinalState

	finalProxiesCount := ClassProxy mareaAllInstalledProxiesCount.
	finalCMCount := CompiledMethod instanceCount.
	finalMDCount := MethodDictionary instanceCount.
	finalMetaclassesCount := Metaclass instanceCount.
	finalMemory := (Smalltalk vmParameterAt: 3).
	
	self log: '------------------------------------------------------------------'.
	self log: 'Information after swapping: '.
	"The amount of proxies can be less than the amount of swapped out classes, since some proxies, like some of the metaclasses, could have been garbage collected."
	self log: 'Proxies installed: ', finalProxiesCount asString.
	self log: 'CompiledMethods: ', finalCMCount asString.
	self log: 'MethodDictionaries: ', finalMDCount asString.
	self log: 'Metaclasses: ', finalMetaclassesCount asString.
	self log: 'Memory used before proxies: ',  finalMemory asString.
	
	
	! !

!ClutterCollector methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 12/13/2011 11:27'!
logInitialState
		
	initialProxiesCount := ClassProxy mareaAllInstalledProxiesCount.
	initialCMCount := CompiledMethod instanceCount.
	initialMDCount := MethodDictionary instanceCount.
	initialMetaclassesCount := Metaclass instanceCount.
	initialMemory := (Smalltalk vmParameterAt: 3).
	
	self log: '------------------------------------------------------------------'.
	self log: 'Information before swapping: '.
	self log: 'Proxies installed: ', initialProxiesCount asString.
	self log: 'CompiledMethods: ', initialCMCount asString.
	self log: 'MethodDictionaries: ', initialMDCount asString.
	self log: 'Metaclasses: ', initialMetaclassesCount asString.
	self log: 'Memory used before proxies: ',  initialMemory asString.
	
	! !

!ClutterCollector methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 12/13/2011 11:13'!
logObjectsToSwapInfo: objectsToSwap
	| methods |
	self log: '------------------------------------------------------------------'.
	self log: 'Information of the classes to swap out: '.
	self log: 'Classes: ',  (objectsToSwap size * 2) asString.
	methods := objectsToSwap  inject: 0  into: [ :total :each | total +  each methodDict size + each class methodDict size].
	self log: 'CompiledMethods: ',  methods asString.
	! !

!ClutterCollector methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 12/13/2011 10:19'!
logger	
	Logger isNil ifTrue: [
		Logger := FixesFileNameLoggerStrategy named: 'Swapper.txt'.
		Logger startLogging].
	^ Logger! !

!ClutterCollector methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 12/13/2011 10:07'!
proxyClass
	^ self class proxyClass! !

!ClutterCollector methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 12/13/2011 10:06'!
proxyClass: aClass
	self class proxyClass: aClass! !

!ClutterCollector methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 12/13/2011 13:01'!
testExampleSwapOutClassesForSomePackages
	"self exampleSwapOutTestMethodsForOnePackage"
	| objectsToSwap timeToInstall timeToUninstall |

	self initializeAndClean.
	self logInitialState.
	
	objectsToSwap := self classesToSwapOutOfPackagesIncludingSubstrings: #('Autotest' 'Gofer' 'Metacello' 'Compression' 'FreeType' 'HelpSystem' 'ProfStef' 'ScriptManager' 'Zinc' 'Sound' 'Shout' 'Tests')
	excludingSubstrings: #('Marea').

	self logObjectsToSwapInfo: objectsToSwap.
		
	timeToInstall := MessageTally time: [
		objectsToSwap do: [:each |  ObjectGraphSwapper new swapOutClass: each].
	].
	self log: 'Time to swap out: ', timeToInstall asString, ' miliseconds'.
	
	
	objectsToSwap := nil.
	self clean.
	self logFinalState.
	self logDifferences.
	! !

TestCase subclass: #ObjectGraphSwapperTest
	instanceVariableNames: 'proxyClass proxyCreatorClass classFactory classProxyClass proxyCreatorClassCreator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Marea-Swapping-Tests'!

ObjectGraphSwapperTest subclass: #ObjectGraphSwapperRealLongTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Marea-Swapping-Tests'!

!ObjectGraphSwapperRealLongTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 12/13/2011 23:43'!
testSwapOutClass
	|  aClassCopy instance objectsToSwap |

	3 timesRepeat: [Smalltalk garbageCollect].
		MareaLogger changeToFileLogger.
	 self swapOutClass: FreeTypeCacheConstants.
 	self swapOutClass: FreeTypeCacheTest.

	(Smalltalk at: #FreeTypeCache) category.
	
	 "self swapOutClass: AutotestTestOneLongRun."
	
	
	"
	Smalltalk allClassesAndTraitsDo: [ :aClass | 
				aClass classPool associationsDo: [ :aBinding | 
				 ] ].
	"
	
	

"	self swapOut: (RBSemanticTest>>#testLiteralScope).
"		
"	self proxyClass mareaUninstallIfNeededAllInstances."! !

!ObjectGraphSwapperRealLongTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 12/12/2011 15:46'!
testSwapOutClasses
	|  aClassCopy instance objectsToSwap |

	3 timesRepeat: [Smalltalk garbageCollect].
	MareaLogger changeToFileLogger.
	objectsToSwap := OrderedCollection new.

	(PackageInfo allPackages select: [:each| each packageName includesSubString: 'Autotest'] ) do: [:aPackage |
		objectsToSwap addAll: (aPackage classes select: [:each | each subclasses isEmpty] )
		].

	objectsToSwap do: [:each | self swapOutClass: each].

"	self swapOut: (RBSemanticTest>>#testLiteralScope).
"		
"	self proxyClass mareaUninstallIfNeededAllInstances."! !

!ObjectGraphSwapperRealLongTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 12/5/2011 12:15'!
testSwapOutCompiledMethods
	|  aClassCopy instance objectsToSwap |

	3 timesRepeat: [Smalltalk garbageCollect].
	MareaLogger disableLogging.
	objectsToSwap := OrderedCollection new.
	(PackageInfo allPackages select: [:each| each packageName includesSubString: 'Test'] ) do: [:aPackage |
		aPackage classes do: [:aClass |
			objectsToSwap addAll: aClass methods
			].
		].
	objectsToSwap  := objectsToSwap asIdentitySet asArray.
	objectsToSwap do: [:method| self swapOut: method].

"	self swapOut: (RBSemanticTest>>#testLiteralScope).
"		
"	self proxyClass mareaUninstallIfNeededAllInstances."! !

!ObjectGraphSwapperTest methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 11/30/2011 14:20'!
classFactory
	^classFactory! !

!ObjectGraphSwapperTest methodsFor: 'helpers' stamp: 'MarianoMartinezPeck 12/13/2011 16:23'!
classProxyClass
	^ classProxyClass  ! !

!ObjectGraphSwapperTest methodsFor: 'helpers' stamp: 'MarianoMartinezPeck 11/30/2011 14:20'!
newClassOrTrait
	"Returns a class for testing"

	^ self newClassWithInstanceVariableNames: ''! !

!ObjectGraphSwapperTest methodsFor: 'helpers' stamp: 'MarianoMartinezPeck 12/9/2011 16:16'!
newClassOrTraitSubclassOf: aClass
	"Returns a class for testing"

	^ self newClassWithInstanceVariableNames: '' superclass: aClass! !

!ObjectGraphSwapperTest methodsFor: 'helpers' stamp: 'MarianoMartinezPeck 12/9/2011 16:17'!
newClassWithInstanceVariableNames: instanceVariableNames
	^ self newClassWithInstanceVariableNames: instanceVariableNames superclass: Object! !

!ObjectGraphSwapperTest methodsFor: 'helpers' stamp: 'MarianoMartinezPeck 12/9/2011 16:16'!
newClassWithInstanceVariableNames: instanceVariableNames superclass: aSuperclass
	"Returns a class for testing, with the specified instance variables."
	
	"| m c metaformat format postFix |

	metaformat := ClassBuilder new
	    computeFormat: #normal instSize: 0
	    forSuper: Object class ccIndex: 0.
	
	format := ClassBuilder new
	    computeFormat: #normal instSize: instanceVariableNames size
	    forSuper: Object ccIndex: 0.

	m := Metaclass new.
	m superclass: Object class.
	m methodDict: MethodDictionary new.
	m setFormat: metaformat.

	c := m new.
	c superclass: Object.
	c methodDict: MethodDictionary new.
	c setFormat: format.

	c setInstVarNames: instanceVariableNames.
	postFix := (DateAndTime now asSeconds) printString.
	c setName: (#ClassForTestToBeDeleted, postFix) asSymbol.
	Smalltalk at: c name put: c."
	
	^ self classFactory
		newSubclassOf: aSuperclass
		instanceVariableNames: instanceVariableNames
		classVariableNames: ''! !

!ObjectGraphSwapperTest methodsFor: 'helpers' stamp: 'MarianoMartinezPeck 10/3/2011 14:23'!
proxyClass
	^ proxyClass ! !

!ObjectGraphSwapperTest methodsFor: 'helpers' stamp: 'MarianoMartinezPeck 10/3/2011 14:23'!
proxyCreatorClass
	^ proxyCreatorClass! !

!ObjectGraphSwapperTest methodsFor: 'helpers' stamp: 'MarianoMartinezPeck 12/12/2011 10:51'!
serializer
	^ FuelMareaSerializer new! !

!ObjectGraphSwapperTest methodsFor: 'setUp - tearDown' stamp: 'MarianoMartinezPeck 12/13/2011 16:23'!
setUp

	proxyClass := RegularObjectProxy.
	proxyCreatorClass := RegularObjectProxy.
		
	"proxyClass := MareaProxyMock.
	proxyCreatorClass := MareaProxyMock."
	
	classProxyClass := ClassProxy.
	proxyCreatorClassCreator := ClassProxy.
	
"	classProxyClass := ClassProxyMock.
	proxyCreatorClassCreator := ClassProxyMock.
"	
	super setUp.
	self setUpClassFactory.
	
	MareaLogger changeToTranscriptLogger.
	(FileDirectory default fileNamesMatching: '*.swap*') 
		do: [ :aFile | FileDirectory default deleteFileNamed: aFile ].
	

	ObjectGraphSwapper resetGlobalTable.
	ObjectGraphSwapper resetGraphID.
	ObjectGraphSwapper resetSharedProxiesTable.  
	ObjectGraphSwapper proxyCreator: self proxyCreatorClass.
	! !

!ObjectGraphSwapperTest methodsFor: 'setUp - tearDown' stamp: 'MarianoMartinezPeck 11/30/2011 14:20'!
setUpClassFactory
	classFactory := ClassFactoryForTestCase new! !

!ObjectGraphSwapperTest methodsFor: 'helpers' stamp: 'MarianoMartinezPeck 12/9/2011 00:03'!
swapIn: anObject	
	anObject name.
	"When using MOCKS, comment the first line and put this one:
	ObjectGraphSwapper new swapInGraphFor: anObject."! !

!ObjectGraphSwapperTest methodsFor: 'helpers' stamp: 'MarianoMartinezPeck 9/29/2011 14:18'!
swapOut: anObject
		ObjectGraphSwapper new swapOutGraph: anObject.
! !

!ObjectGraphSwapperTest methodsFor: 'helpers' stamp: 'MarianoMartinezPeck 11/30/2011 14:48'!
swapOutClass: aClass
		ObjectGraphSwapper new swapOutClass: aClass.
! !

!ObjectGraphSwapperTest methodsFor: 'setUp - tearDown' stamp: 'MarianoMartinezPeck 12/7/2011 12:21'!
tearDown
	ObjectGraphSwapperTest compileAll.
	self classFactory cleanUp.! !

!ObjectGraphSwapperTest methodsFor: 'tests basic' stamp: 'MarianoMartinezPeck 12/2/2011 13:07'!
testAmountOfProxiesAndBecome
	"We test that we creat the right amount of proxies, that is, that after a GC runs, we should only have proxies for the root and the facade objects. In addition, we test we correctly did the become. "
	| a b proxiesCount |

	3 timesRepeat: [Smalltalk garbageCollect].
	proxiesCount := self proxyClass instanceCount.

	a := ClassWith2Var new.
	b := ClassWith1Var new. 
	"Do not put a string or something like that because otherwise it is stored in the literals of the method and hence it is considered as a shared object"
	b var1: 6.
	a var1: (Point x: 4 y: 2).
	a var2: b.

	self swapOut: a.
	
	3 timesRepeat: [Smalltalk garbageCollect].
	"One proxy for the root A and one proxy for the shared object B."
	self assert: self proxyClass instanceCount equals: proxiesCount + 2.
	self assert: a mareaIsProxy.  
	self assert: b mareaIsProxy. 
! !

!ObjectGraphSwapperTest methodsFor: 'tests specials' stamp: 'MarianoMartinezPeck 9/29/2011 14:20'!
testAmountOfProxiesAndBecomeWithSpecialObjects
	"We test that we creat the right amount of proxies, that is, that after a GC runs, we should only have proxies for the root and the facade objects. In addition, we test we correctly did the become. We should NOT create proxies for nil, true or false and some other special objects "
	| a b proxiesCount c |

	3 timesRepeat: [Smalltalk garbageCollect].
	proxiesCount := self proxyClass instanceCount.

	a := OrderedCollection new.
	b := Smalltalk. 
	c := Processor.
	"Do not put a string or something like that because otherwise it is stored in the literals of the method and hence it is considered as a shared object"
	a add: b.
	a add: c.

	self swapOut: a
	.
	3 timesRepeat: [Smalltalk garbageCollect].
	self assert: self proxyClass instanceCount equals: proxiesCount + 1.
	self assert: a mareaIsProxy. 
	
	self swapIn: a.	
	3 timesRepeat: [Smalltalk garbageCollect].

	"One proxy for the root A and NONE proxy for the shared object B because it is nil."
	self assert: self proxyClass instanceCount equals: proxiesCount.
	self assert: a mareaClass = OrderedCollection. 
	self assert: b == Smalltalk. 
	self assert: b == a first.
	self assert: c == Processor.
	self assert: c == a second. 

	! !

!ObjectGraphSwapperTest methodsFor: 'tests specials' stamp: 'MarianoMartinezPeck 9/29/2011 14:22'!
testAmountOfProxiesAndBecomeWithTrueNilFalse
	"We test that we creat the right amount of proxies, that is, that after a GC runs, we should only have proxies for the root and the facade objects. In addition, we test we correctly did the become. We should NOT create proxies for nil, true or false. "
	| a b proxiesCount c d |

	3 timesRepeat: [Smalltalk garbageCollect].
	proxiesCount := self proxyClass instanceCount.

	a := OrderedCollection new.
	b := nil. 
	c := true.
	d := false.
	"Do not put a string or something like that because otherwise it is stored in the literals of the method and hence it is considered as a shared object"
	a add: b.
	a add: c.
	a add: d.

	self swapOut: a.
	3 timesRepeat: [Smalltalk garbageCollect].
	self assert: self proxyClass instanceCount equals: proxiesCount + 1.
	self assert: a mareaIsProxy. 
	
	self swapIn: a.	
	3 timesRepeat: [Smalltalk garbageCollect].

	"One proxy for the root A and NONE proxy for the shared object B because it is nil."
	self assert: self proxyClass instanceCount equals: proxiesCount.
	self assert: a class = OrderedCollection. 
	self assert: b isNil. 
	self assert: b == a first.
	self assert: c.
	self assert: c == a second. 
	self deny: d. 
	self assert: d == a third.
	
	! !

!ObjectGraphSwapperTest methodsFor: 'tests class swapping' stamp: 'MarianoMartinezPeck 12/1/2011 19:26'!
testClassAndMetaclassAreGarbageCollected

	| aClass metaclassesSize |

	[	
	10 timesRepeat: [Smalltalk garbageCollect].
	metaclassesSize := Metaclass instanceCount.

	aClass := self newClassOrTrait.
	aClass compileSilently: 'foo ^ 42'.

	10 timesRepeat: [Smalltalk garbageCollect].
	self assert: (metaclassesSize + 1) equals: Metaclass instanceCount.

	self swapOutClass: aClass.
	10 timesRepeat: [Smalltalk garbageCollect].
	self assert: aClass mareaIsProxy. 
	DebuggerMethodMap cleanUp.
	10 timesRepeat: [Smalltalk garbageCollect].
	"I comment this line because sometimes it works and sometimes it doesnt. However, if I close the test, run a garbage collect from outside, the instaces are garbage collected. So I think it is something related to the tests"
	"self assert: metaclassesSize equals: Metaclass instanceCount."
	
	self swapIn: aClass.	
	10 timesRepeat: [Smalltalk garbageCollect].
	self assert: (metaclassesSize + 1) equals: Metaclass instanceCount.
	
	 ] ensure: [ aClass mareaIsProxy ifTrue: [ self swapIn: aClass.  ] ]! !

!ObjectGraphSwapperTest methodsFor: 'tests basic' stamp: 'MarianoMartinezPeck 9/29/2011 14:24'!
testFacadeObjectNotAnymoreNoIntersection
	"This tests that a graph is loaded back when the ROOT receives a message and when there is NO intersection probem, that is, there is no swapping of external graphs that refer to our facade objects. In addition, it tests that a facade object to which we have created a proxy, is garbage collected because nobody else point to it. "
	| a b proxiesCount |
	
	3 timesRepeat: [Smalltalk garbageCollect].
	proxiesCount := self proxyClass instanceCount.
	
	a := ClassWith2Var new.
	b := ClassWith1Var new. 
	"Do not put a string or something like that because otherwise it is stored in the literals of the method and hence it is considered as a shared object"
	b var1: 6.
	a var1: (Point x: 4 y: 2).
	a var2: b.

	self swapOut: a.
	3 timesRepeat: [Smalltalk garbageCollect].
	
	"Now lets say that nobody else point to the facade object B"	
	self assert: self proxyClass instanceCount equals: proxiesCount + 2.
	b := nil.
	3 timesRepeat: [Smalltalk garbageCollect].
	self assert: self proxyClass instanceCount equals: proxiesCount + 1.
	
	self swapIn: a.
	3 timesRepeat: [Smalltalk garbageCollect].
	self assert: self proxyClass instanceCount equals: proxiesCount.
	self assert: a var2 var1 equals: 6.
	self assert: a var1 equals: 4@2.
	! !

!ObjectGraphSwapperTest methodsFor: 'tests intersection' stamp: 'MarianoMartinezPeck 9/29/2011 14:40'!
testIntersectionOutAOutCInAInC
	"This tests the following scenario: Both, object AAA and CCC, point to BBB. 
	- AAA is swapped out first.
	- CCC is swapped out.
	- AAA is swapped in.
	- CCC is swapped in"
	| a b proxiesCount c |
	
	3 timesRepeat: [Smalltalk garbageCollect].
	proxiesCount := self proxyClass instanceCount.
	
	a := ClassWith1Var new.
	b := (Point x: 4 y: 2).
	c := ClassWith1Var new. 
	c var1: b.
	a var1: b.

	self assert: ObjectGraphSwapper globalSharedProxiesTable size equals: 0.
	self assert: ObjectGraphSwapper globalGraphTable size equals: 0.
	
	self swapOut: a.

	3 timesRepeat: [Smalltalk garbageCollect].
	
	self assert: ObjectGraphSwapper globalSharedProxiesTable size equals: 0.
	self assert: ObjectGraphSwapper globalGraphTable size equals: 1.
	self assert: (ObjectGraphSwapper globalGraphTable at: 1) size equals: 2.
		
	"There should be a proxy for A and B"	
	self assert: self proxyClass instanceCount equals: proxiesCount + 2.
	self assert: b mareaIsProxy.
	self assert: a mareaIsProxy.
		
	"Now we swap another graph, C, which has intersection with A"
	self swapOut: c.
	self assert: ObjectGraphSwapper globalSharedProxiesTable size equals: 1.
	self assert: ObjectGraphSwapper globalGraphTable size equals: 2.
	self assert: (ObjectGraphSwapper globalGraphTable at: 1) size equals: 2.
	self assert: (ObjectGraphSwapper globalGraphTable at: 2) size equals: 2.
		

	"We have to be sure that when finding a proxy in the graph to serialize, we do not uninstall it"	
	self assert: b mareaIsProxy.
	self assert: c mareaIsProxy.


	"Lets clean the pointers from the test"
	b := nil.
	3 timesRepeat: [Smalltalk garbageCollect].

	
	self swapIn: a.
	3 timesRepeat: [Smalltalk garbageCollect].
	self assert: a var1 equals: (Point x: 4 y: 2).

	self swapIn: c.
	self deny: c mareaIsProxy.
	self deny: c var1 mareaIsProxy.
	self assert: c var1 == a var1.
	! !

!ObjectGraphSwapperTest methodsFor: 'tests intersection' stamp: 'MarianoMartinezPeck 9/29/2011 14:28'!
testIntersectionOutAOutCInCInA
	"This tests the following scenario: Both, object AAA and CCC, point to BBB. 
	- AAA is swapped out first.
	- CCC is swapped out.
	- CCC is swapped in
	- AAA is swapped in.
	It is important to notice in this case that when C is swapped in, B it is not. There will be a proxy there. B will only be replaced with the original object, only when the graph where it was serialized, is swapped in.
	"
	| a b proxiesCount c |
	
	3 timesRepeat: [Smalltalk garbageCollect].
	proxiesCount := self proxyClass instanceCount.
	
	a := ClassWith1Var new.
	b := (Point x: 4 y: 2).
	c := ClassWith1Var new. 
	c var1: b.
	a var1: b.

	self assert: ObjectGraphSwapper globalSharedProxiesTable size equals: 0.
	self assert: ObjectGraphSwapper globalGraphTable size equals: 0.
	
	self swapOut: a.

	3 timesRepeat: [Smalltalk garbageCollect].
	
	self assert: ObjectGraphSwapper globalSharedProxiesTable size equals: 0.
	self assert: ObjectGraphSwapper globalGraphTable size equals: 1.
	self assert: (ObjectGraphSwapper globalGraphTable at: 1) size equals: 2.
		
	"There should be a proxy for A and B"	
	self assert: self proxyClass instanceCount equals: proxiesCount + 2.
	self assert: b mareaIsProxy.
	self assert: a mareaIsProxy.
		
	"Now we swap another graph, C, which has intersection with A"
	self swapOut: c.
	self assert: ObjectGraphSwapper globalSharedProxiesTable size equals: 1.
	self assert: ObjectGraphSwapper globalGraphTable size equals: 2.
	self assert: (ObjectGraphSwapper globalGraphTable at: 1) size equals: 2.
	self assert: (ObjectGraphSwapper globalGraphTable at: 2) size equals: 2.
		

	"We have to be sure that when finding a proxy in the graph to serialize, we do not uninstall it"	
	self assert: b mareaIsProxy.
	self assert: c mareaIsProxy.


	"Lets clean the pointers from the test"
	b := nil.
	3 timesRepeat: [Smalltalk garbageCollect].

	self swapIn: c.
	self deny: c mareaIsProxy.
	self assert: c var1 mareaIsProxy.

	self swapIn: a.
	3 timesRepeat: [Smalltalk garbageCollect].
	self assert: a var1 equals: (Point x: 4 y: 2).
	self deny: c var1 mareaIsProxy.
	self assert: c var1 == a var1.
! !

!ObjectGraphSwapperTest methodsFor: 'tests intersection' stamp: 'MarianoMartinezPeck 9/29/2011 14:29'!
testIntersectionOutAOutCInCInB
	"This tests the following scenario: Both, object AAA and CCC, point to BBB. 
	- AAA is swapped out first.
	- CCC is swapped out.
	- CCC is swapped in.
	- BBB is swapped in
	It is important to notice in this case that when C is swapped in, B it is not. There will be a proxy there. B will only be replaced with the original object, only when the graph where it was serialized, is swapped in.
	"
	| a b proxiesCount c |
	
	3 timesRepeat: [Smalltalk garbageCollect].
	proxiesCount := self proxyClass instanceCount.
	
	a := ClassWith1Var new.
	b := (Point x: 4 y: 2).
	c := ClassWith1Var new. 
	c var1: b.
	a var1: b.

	self assert: ObjectGraphSwapper globalSharedProxiesTable size equals: 0.
	self assert: ObjectGraphSwapper globalGraphTable size equals: 0.
	
	self swapOut: a.

	3 timesRepeat: [Smalltalk garbageCollect].
	
	self assert: ObjectGraphSwapper globalSharedProxiesTable size equals: 0.
	self assert: ObjectGraphSwapper globalGraphTable size equals: 1.
	self assert: (ObjectGraphSwapper globalGraphTable at: 1) size equals: 2.
		
	"There should be a proxy for A and B"	
	self assert: self proxyClass instanceCount equals: proxiesCount + 2.
	self assert: b mareaIsProxy.
	self assert: a mareaIsProxy.
		
	"Now we swap another graph, C, which has intersection with A"
	self swapOut: c.
	self assert: ObjectGraphSwapper globalSharedProxiesTable size equals: 1.
	self assert: ObjectGraphSwapper globalGraphTable size equals: 2.
	self assert: (ObjectGraphSwapper globalGraphTable at: 1) size equals: 2.
	self assert: (ObjectGraphSwapper globalGraphTable at: 2) size equals: 2.
		

	"We have to be sure that when finding a proxy in the graph to serialize, we do not uninstall it"	
	self assert: b mareaIsProxy.
	self assert: c mareaIsProxy.


	"Lets clean the pointers from the test"
	b := nil.
	3 timesRepeat: [Smalltalk garbageCollect].

	self swapIn: c.
	self deny: c mareaIsProxy.
	self assert: c var1 mareaIsProxy.

	self swapIn: c var1.
	3 timesRepeat: [Smalltalk garbageCollect].
	self deny: c var1 mareaIsProxy.
	self assert: a var1 equals: (Point x: 4 y: 2).
	self assert: c var1 == a var1.
	! !

!ObjectGraphSwapperTest methodsFor: 'tests basic' stamp: 'MarianoMartinezPeck 9/29/2011 14:30'!
testRootObjectNotAnymoreNoIntersection
	"This tests that a graph is loaded back when a facade object receives a message and when there is NO intersection probem, that is, there is no swapping of external graphs that refer to our facade objects. In addition, it tests that the root object to which we have created a proxy, is garbage collected because nobody else point to it. "
	| a b proxiesCount |
	
	3 timesRepeat: [Smalltalk garbageCollect].
	proxiesCount := self proxyClass instanceCount.
	
	a := ClassWith2Var new.
	b := ClassWith1Var new. 
	"Do not put a string or something like that because otherwise it is stored in the literals of the method and hence it is considered as a shared object"
	b var1: 6.
	a var1: (Point x: 4 y: 2).
	a var2: b.

	self swapOut: a.
	3 timesRepeat: [Smalltalk garbageCollect].
	
	"Now lets say that nobody else point to the root object A"	
	self assert: self proxyClass instanceCount equals: proxiesCount + 2.
	a := nil.
	3 timesRepeat: [Smalltalk garbageCollect].
	self assert: self proxyClass instanceCount equals: proxiesCount + 1.
	
	self swapIn: b.
	3 timesRepeat: [Smalltalk garbageCollect].
	self assert: self proxyClass instanceCount equals: proxiesCount.
	self assert: b var1 equals: 6.
! !

!ObjectGraphSwapperTest methodsFor: 'tests proxies' stamp: 'MarianoMartinezPeck 12/13/2011 16:35'!
testSerialiationOfClassProxy
	| aProxy materializedProxy |
	"This method tests that an instance of a proxy can be serialized and materialized WITHOUT being uninstalled, that is, without receiving a message that should be intercepted. "
	
	aProxy := self classProxyClass newProxy.
	aProxy mareaSetPosition: 42 setGraphID: 24.
	"Even we have serialized the proxy, it should continue to be a proxy and it should raise error"
	self serializer serializeAndWriteObject: aProxy to: 'testSerialiationOfClassProxy.swap'.
	materializedProxy := self serializer materializeObjectFrom: 'testSerialiationOfClassProxy.swap'.
	self assert: materializedProxy mareaPosition equals: 42.
	self assert: materializedProxy mareaGraphID equals: 24.
	self assert: materializedProxy mareaClass = self classProxyClass.
	self assert: materializedProxy mareaIsWellInitialized.! !

!ObjectGraphSwapperTest methodsFor: 'tests proxies' stamp: 'MarianoMartinezPeck 12/13/2011 16:37'!
testSerialiationOfClassProxyInsideAGraph
	| aProxy materializedObject anObject |
	"This method tests that an instance of a proxy can be serialized and materialized  inside a graph WITHOUT being uninstalled, that is, without receiving a message that should be intercepted. "
	
	aProxy := self classProxyClass newProxy.
	aProxy mareaSetPosition: 42 setGraphID: 24.
	anObject := ClassWith2Var new.
	anObject var1: aProxy.
	anObject var2:  'mariano'.
	
	"Even we have serialized the proxy, it should continue to be a proxy and it should raise error"
	self serializer serializeAndWriteObject: anObject to: 'testSerialiationOfProxyInsideAGraph.swap'.
	materializedObject := self serializer materializeObjectFrom: 'testSerialiationOfProxyInsideAGraph.swap'.
	self assert: materializedObject var2 equals: 'mariano'.	
	self assert: materializedObject var1 mareaPosition equals: 42.
	self assert: materializedObject var1 mareaGraphID equals: 24.
	self assert: materializedObject var1 mareaClass = self classProxyClass.
	self assert: materializedObject var1 mareaIsWellInitialized.
	! !

!ObjectGraphSwapperTest methodsFor: 'tests proxies' stamp: 'MarianoMartinezPeck 12/13/2011 16:28'!
testSerialiationOfProxy
	| aProxy materializedProxy |
	"This method tests that an instance of a proxy can be serialized and materialized WITHOUT being uninstalled, that is, without receiving a message that should be intercepted. "
	
	aProxy := self proxyClass newProxy.
	aProxy mareaSetPosition: 42 setGraphID: 24.
	"Even we have serialized the proxy, it should continue to be a proxy and it should raise error"
	self serializer serializeAndWriteObject: aProxy to: 'testSerialiationOfProxy.swap'.
	materializedProxy := self serializer materializeObjectFrom: 'testSerialiationOfProxy.swap'.
	self assert: materializedProxy mareaPosition equals: 42.
	self assert: materializedProxy mareaGraphID equals: 24.
	self assert: materializedProxy mareaClass = self proxyClass.! !

!ObjectGraphSwapperTest methodsFor: 'tests proxies' stamp: 'MarianoMartinezPeck 12/13/2011 16:16'!
testSerialiationOfProxyInsideAGraph
	| aProxy materializedObject anObject |
	"This method tests that an instance of a proxy can be serialized and materialized  inside a graph WITHOUT being uninstalled, that is, without receiving a message that should be intercepted. "
	
	aProxy := self proxyClass newProxy.
	aProxy mareaSetPosition: 42 setGraphID: 24.
	anObject := ClassWith2Var new.
	anObject var1: aProxy.
	anObject var2:  'mariano'.
	
	"Even we have serialized the proxy, it should continue to be a proxy and it should raise error"
	self serializer serializeAndWriteObject: anObject to: 'testSerialiationOfProxyInsideAGraph.swap'.
	materializedObject := self serializer materializeObjectFrom: 'testSerialiationOfProxyInsideAGraph.swap'.
	self assert: materializedObject var2 equals: 'mariano'.	
	self assert: materializedObject var1 mareaPosition equals: 42.
	self assert: materializedObject var1 mareaGraphID equals: 24.
	self assert: materializedObject var1 mareaClass = self proxyClass.
	! !

!ObjectGraphSwapperTest methodsFor: 'tests proxies' stamp: 'MarianoMartinezPeck 12/13/2011 16:16'!
testSerialiationOfProxyInsideAnArray
	| aProxy materializedObject anObject |
	"This method tests that an instance of a proxy can be serialized and materialized  inside an array  WITHOUT being uninstalled, that is, without receiving a message that should be intercepted. "
	
	aProxy := self proxyClass newProxy.
	aProxy mareaSetPosition: 42 setGraphID: 24.
	anObject := Array with: aProxy.
	
	"Even we have serialized the proxy, it should continue to be a proxy and it should raise error"
	self serializer serializeAndWriteObject: anObject to: 'testSerialiationOfProxyInsideAnArray.swap'.
	materializedObject := self serializer materializeObjectFrom: 'testSerialiationOfProxyInsideAnArray.swap'.
	self assert: materializedObject first mareaPosition equals: 42.
	self assert: materializedObject first mareaGraphID equals: 24.
	self assert: materializedObject var1 mareaClass = self proxyClass.
	
	! !

!ObjectGraphSwapperTest methodsFor: 'tests pending' stamp: 'MarianoMartinezPeck 9/15/2011 12:17'!
testSomethingOptimizedByFuel! !

!ObjectGraphSwapperTest methodsFor: 'tests pending' stamp: 'MarianoMartinezPeck 9/15/2011 10:48'!
testSomethingWithNilsInside! !

!ObjectGraphSwapperTest methodsFor: 'tests class swapping' stamp: 'MarianoMartinezPeck 12/1/2011 16:29'!
testSwapOutClassAndTestMetaclassIsProxified
	| aClass aClassCopy aClassClassCopy metaclass |

	3 timesRepeat: [Smalltalk garbageCollect].

	aClass := self newClassOrTrait.
	aClass class compileSilently: 'foo ^ 42'.
	aClassClassCopy := aClass class veryDeepCopy.
	metaclass := aClass class. 

	self swapOutClass: aClass.
	3 timesRepeat: [Smalltalk garbageCollect].
	self assert: aClass mareaIsProxy. 
	self assert: metaclass mareaIsProxy. 
	
	self swapIn: aClass.	
	3 timesRepeat: [Smalltalk garbageCollect].

	self deny: aClass mareaIsProxy. 
	self deny: aClass class mareaIsProxy. 

	self assert: aClass class name equals: aClassClassCopy name.
	self assert: aClass class methodDict equals: aClassClassCopy methodDict.
	self assert: aClass class subclasses equals: aClassClassCopy subclasses.
	self assert: aClass class format equals: aClassClassCopy format.! !

!ObjectGraphSwapperTest methodsFor: 'tests class swapping' stamp: 'MarianoMartinezPeck 12/2/2011 10:19'!
testSwapOutClassSwapInByClass

	| aClass aClassCopy |

	3 timesRepeat: [Smalltalk garbageCollect].

	aClass := self newClassOrTrait.
	aClass compileSilently: 'foo ^ 42'.
	aClassCopy	:= aClass veryDeepCopy.

	self swapOutClass: aClass.
	3 timesRepeat: [Smalltalk garbageCollect].
	self assert: aClass mareaIsProxy. 
	
	self swapIn: aClass.	
	3 timesRepeat: [Smalltalk garbageCollect].

	self deny: aClass mareaIsProxy. 
	self assert: aClass name equals: aClassCopy name.
	self assert: aClass methodDict equals: aClassCopy methodDict.
	self assert: aClass subclasses equals: aClassCopy subclasses.
	self assert: aClass format equals: aClassCopy format.
! !

!ObjectGraphSwapperTest methodsFor: 'tests class swapping' stamp: 'MarianoMartinezPeck 12/12/2011 14:46'!
testSwapOutClassSwapInByClassPool

	| aClass aClassCopy aClassClassPool |

	3 timesRepeat: [Smalltalk garbageCollect].

	aClass := self newClassOrTrait.
	aClass compileSilently: 'foo ^ 42'.
	aClass addClassVarNamed: 'Something'.
	aClass class compileSilently: 'something ^ Something'.
	aClass class compileSilently: 'something: a  Something := a'.
	aClassCopy	:= aClass veryDeepCopy.
	aClass perform: #something: with: (ClassWith1Var var1: 'foo').
	aClassClassPool := aClass classPool at: #Something.

	self swapOutClass: aClass.
	3 timesRepeat: [Smalltalk garbageCollect].
	self assert: aClass mareaIsProxy. 
	self assert: aClassClassPool mareaIsProxy. 
	
	self swapIn: aClassClassPool.	
	3 timesRepeat: [Smalltalk garbageCollect].

	self deny: aClass mareaIsProxy. 
	self deny: aClassClassPool mareaIsProxy.
	self assert: aClassClassPool var1 = 'foo'.
	self assert: aClass name equals: aClassCopy name.
	self assert: aClass methodDict equals: aClassCopy methodDict.
	self assert: aClass subclasses equals: aClassCopy subclasses.
	self assert: aClass format equals: aClassCopy format.
! !

!ObjectGraphSwapperTest methodsFor: 'tests class swapping' stamp: 'MarianoMartinezPeck 12/13/2011 16:09'!
testSwapOutClassSwapInByInstance

	| aClass aClassCopy instance |

	3 timesRepeat: [Smalltalk garbageCollect].

	aClass := self newClassWithInstanceVariableNames: 'foo'.
	aClass compileSilently: 'foo ^ foo'.
	aClass compileSilently: 'foo: aFoo 
					foo := aFoo'.
	instance := aClass new.
	instance perform: #foo: with: 42.
	aClassCopy	:= aClass veryDeepCopy.

	self swapOutClass: aClass.
	3 timesRepeat: [Smalltalk garbageCollect].
	self assert: aClass mareaIsProxy. 
	
	instance mareaIsProxy inspect.	
	3 timesRepeat: [Smalltalk garbageCollect].

	self assert: (instance perform: #foo) = 42.
	self assert: instance class == aClass.
	self deny: aClass mareaIsProxy. 
	self assert: aClass name equals: aClassCopy name.
	self assert: aClass methodDict equals: aClassCopy methodDict.
	self assert: aClass subclasses equals: aClassCopy subclasses.
	self assert: aClass format equals: aClassCopy format.
	
! !

!ObjectGraphSwapperTest methodsFor: 'tests class swapping' stamp: 'MarianoMartinezPeck 12/2/2011 10:22'!
testSwapOutClassSwapInByMetaclass

	| aClass aClassCopy metaclass aClassClassCopy |

	3 timesRepeat: [Smalltalk garbageCollect].

	aClass := self newClassOrTrait.
	aClass compileSilently: 'foo ^ 42'.
	aClassCopy	:= aClass veryDeepCopy.
	metaclass := aClass class.
	aClassClassCopy := metaclass veryDeepCopy.
	
	self swapOutClass: aClass.
	3 timesRepeat: [Smalltalk garbageCollect].
	self assert: aClass mareaIsProxy. 
	
	self swapIn: metaclass.	
	3 timesRepeat: [Smalltalk garbageCollect].

	self deny: aClass mareaIsProxy. 
	self assert: aClass name equals: aClassCopy name.
	self assert: aClass methodDict equals: aClassCopy methodDict.
	self assert: aClass subclasses equals: aClassCopy subclasses.
	self assert: aClass format equals: aClassCopy format.

	self assert: aClass class name equals: aClassClassCopy name.
	self assert: aClass class methodDict equals: aClassClassCopy methodDict.
	self assert: aClass class subclasses equals: aClassClassCopy subclasses.
	self assert: aClass class format equals: aClassClassCopy format.! !

!ObjectGraphSwapperTest methodsFor: 'tests class swapping' stamp: 'MarianoMartinezPeck 12/12/2011 15:01'!
testSwapOutClassThenSwapOutSometihingWithAClassPool

	| aClass aClassCopy aClassName anObject aClassClassPool |

	3 timesRepeat: [Smalltalk garbageCollect].

	aClass := self newClassOrTrait.
	aClass compileSilently: 'foo ^ 42'.
	aClass addClassVarNamed: 'Something'.
	aClass class compileSilently: 'something ^ Something'.
	aClass class compileSilently: 'something: a  Something := a'.
	aClassCopy	:= aClass veryDeepCopy.
	aClass perform: #something: with: (ClassWith1Var var1: 'foo').
	aClassClassPool := aClass classPool at: #Something.

	anObject := ClassWith2Var new.
	anObject var1: 'foo'.
	anObject var2: aClassClassPool.
	
	self swapOut: anObject.
	self assert: anObject mareaIsProxy. 
	self assert: aClassClassPool mareaIsProxy. 
	

	self swapOutClass: aClass.
	3 timesRepeat: [Smalltalk garbageCollect].
	self assert: aClass mareaIsProxy. 
	self assert: anObject mareaIsProxy. 
	self assert: aClassClassPool mareaIsProxy. 
	

	self swapIn: aClassClassPool.	

	3 timesRepeat: [Smalltalk garbageCollect].
	self deny: anObject mareaIsProxy. 
	self deny: aClassClassPool mareaIsProxy. 
	self assert: aClass mareaIsProxy. 
	
	self assert: anObject var1 = 'foo'.
	self assert: aClassClassPool var1 = 'foo'.
	
	self swapIn: aClass.

	self deny: aClass mareaIsProxy. 	
		
	self assert: (aClass classPool at: #Something) == aClassClassPool.
	self assert: aClass name equals: aClassCopy name.
	self assert: aClass methodDict equals: aClassCopy methodDict.
	self assert: aClass subclasses equals: aClassCopy subclasses.
	self assert: aClass format equals: aClassCopy format.
	self assert: anObject var2 == aClassClassPool.
! !

!ObjectGraphSwapperTest methodsFor: 'tests class swapping' stamp: 'MarianoMartinezPeck 12/12/2011 15:10'!
testSwapOutClassThenSwapOutSometihingWithAClassPool2

	| aClass aClassCopy aClassName anObject aClassClassPool |

	3 timesRepeat: [Smalltalk garbageCollect].

	aClass := self newClassOrTrait.
	aClass compileSilently: 'foo ^ 42'.
	aClass addClassVarNamed: 'Something'.
	aClass class compileSilently: 'something ^ Something'.
	aClass class compileSilently: 'something: a  Something := a'.
	aClassCopy	:= aClass veryDeepCopy.
	aClass perform: #something: with: (ClassWith1Var var1: 'foo').
	aClassClassPool := aClass classPool at: #Something.

	anObject := ClassWith2Var new.
	anObject var1: 'foo'.
	anObject var2: aClassClassPool.


	self swapOutClass: aClass.
	3 timesRepeat: [Smalltalk garbageCollect].
	self assert: aClass mareaIsProxy. 
	self assert: aClassClassPool mareaIsProxy. 

	
	self swapOut: anObject.
	self assert: anObject mareaIsProxy. 
	self assert: aClass mareaIsProxy. 
	self assert: aClassClassPool mareaIsProxy. 
	
	
	self swapIn: aClassClassPool.	

	3 timesRepeat: [Smalltalk garbageCollect].
	self deny: aClass mareaIsProxy. 
	self deny: aClassClassPool mareaIsProxy. 
	self assert: anObject mareaIsProxy. 
	
	self swapIn: anObject.

	self deny: anObject mareaIsProxy. 	
	
	self assert: anObject var1 = 'foo'.
	self assert: aClassClassPool var1 = 'foo'.
	
		
	self assert: (aClass classPool at: #Something) == aClassClassPool.
	self assert: aClass name equals: aClassCopy name.
	self assert: aClass methodDict equals: aClassCopy methodDict.
	self assert: aClass subclasses equals: aClassCopy subclasses.
	self assert: aClass format equals: aClassCopy format.
	self assert: anObject var2 == aClassClassPool.
! !

!ObjectGraphSwapperTest methodsFor: 'tests class swapping' stamp: 'MarianoMartinezPeck 12/12/2011 12:01'!
testSwapOutClassThenSwapOutSometihingWithItAsGlobal

	| aClass aClassCopy aClassName anObject |

	3 timesRepeat: [Smalltalk garbageCollect].

	aClass := self newClassOrTrait.
	aClass compileSilently: 'foo ^ 42'.
	aClassCopy	:= aClass veryDeepCopy.
	aClassName := aClass name.

	self swapOutClass: aClass.
	3 timesRepeat: [Smalltalk garbageCollect].
	self assert: aClass mareaIsProxy. 
	
	anObject := ClassWith2Var new.
	anObject var1: 'foo'.
	anObject var2: (Smalltalk at: aClassName).
	
	self swapOut: anObject.
	self assert: anObject mareaIsProxy. 
	
	self swapIn: anObject.	
	3 timesRepeat: [Smalltalk garbageCollect].
	self deny: anObject mareaIsProxy. 
	self assert: anObject var1 = 'foo'.
	self assert: aClass mareaIsProxy. 
	
	self swapIn: aClass.

	self deny: aClass mareaIsProxy. 	
	self assert: aClass name equals: aClassCopy name.
	self assert: aClass methodDict equals: aClassCopy methodDict.
	self assert: aClass subclasses equals: aClassCopy subclasses.
	self assert: aClass format equals: aClassCopy format.
	self assert: anObject var2 == aClass.
! !

!ObjectGraphSwapperTest methodsFor: 'tests class swapping' stamp: 'MarianoMartinezPeck 12/12/2011 12:01'!
testSwapOutClassThenSwapOutSometihingWithItAsGlobal2

	| aClass aClassCopy aClassName anObject |

	3 timesRepeat: [Smalltalk garbageCollect].

	aClass := self newClassOrTrait.
	aClass compileSilently: 'foo ^ 42'.
	aClassCopy	:= aClass veryDeepCopy.
	aClassName := aClass name.

	self swapOutClass: aClass.
	3 timesRepeat: [Smalltalk garbageCollect].
	self assert: aClass mareaIsProxy. 
	
	anObject := ClassWith2Var new.
	anObject var1: 'foo'.
	anObject var2: (Smalltalk at: aClassName).
	
	self swapOut: anObject.
	self assert: anObject mareaIsProxy. 
	
	self swapIn: anObject.	
	3 timesRepeat: [Smalltalk garbageCollect].
	self deny: anObject mareaIsProxy. 
	self assert: anObject var1 = 'foo'.
	self assert: aClass mareaIsProxy. 
	
	self swapIn: anObject var2.

	self deny: aClass mareaIsProxy. 	
	self assert: aClass name equals: aClassCopy name.
	self assert: aClass methodDict equals: aClassCopy methodDict.
	self assert: aClass subclasses equals: aClassCopy subclasses.
	self assert: aClass format equals: aClassCopy format.
	self assert: anObject var2 == aClass.
! !

!ObjectGraphSwapperTest methodsFor: 'tests class swapping' stamp: 'MarianoMartinezPeck 12/12/2011 12:01'!
testSwapOutClassThenSwapOutSometihingWithItAsGlobal3

	| aClass aClassCopy aClassName anObject |

	3 timesRepeat: [Smalltalk garbageCollect].

	aClass := self newClassOrTrait.
	aClass compileSilently: 'foo ^ 42'.
	aClassCopy	:= aClass veryDeepCopy.
	aClassName := aClass name.

	self swapOutClass: aClass.
	3 timesRepeat: [Smalltalk garbageCollect].
	self assert: aClass mareaIsProxy. 
	
	anObject := ClassWith2Var new.
	anObject var1: 'foo'.
	anObject var2: (Smalltalk at: aClassName).
	
	self swapOut: anObject.
	self assert: anObject mareaIsProxy. 
	
	self swapIn: aClass.

	self deny: aClass mareaIsProxy. 	
	self assert: aClass name equals: aClassCopy name.
	self assert: aClass methodDict equals: aClassCopy methodDict.
	self assert: aClass subclasses equals: aClassCopy subclasses.
	self assert: aClass format equals: aClassCopy format.
	
	self swapIn: anObject.	
		
	3 timesRepeat: [Smalltalk garbageCollect].
	self deny: anObject mareaIsProxy. 
	self assert: anObject var1 = 'foo'.
	self assert: anObject var2 == aClass.
	

! !

!ObjectGraphSwapperTest methodsFor: 'tests class swapping' stamp: 'MarianoMartinezPeck 12/1/2011 12:23'!
testSwapOutClassWithLiveInstance

	| aClass aClassCopy instance |

	3 timesRepeat: [Smalltalk garbageCollect].

	aClass := self newClassWithInstanceVariableNames: 'foo'.
	aClass compileSilently: 'foo ^ foo'.
	aClass compileSilently: 'foo: aFoo 
					foo := aFoo'.
	instance := aClass new.
	instance perform: #foo: with: 42.
	aClassCopy	:= aClass veryDeepCopy.

	self swapOutClass: aClass.
	3 timesRepeat: [Smalltalk garbageCollect].
	self assert: aClass mareaIsProxy. 
	
	self swapIn: aClass.	
	3 timesRepeat: [Smalltalk garbageCollect].

	self deny: aClass mareaIsProxy. 
	self assert: aClass name equals: aClassCopy name.
	self assert: aClass methodDict equals: aClassCopy methodDict.
	self assert: aClass subclasses equals: aClassCopy subclasses.
	self assert: aClass format equals: aClassCopy format.
	self assert: instance class == aClass.
	self assert: (instance perform: #foo) = 42.
! !

!ObjectGraphSwapperTest methodsFor: 'tests class swapping' stamp: 'MarianoMartinezPeck 12/9/2011 16:19'!
testSwapOutClassWithSubclassSwapInBySubclass

	| aClass aClassCopy aClassSubclass |

	3 timesRepeat: [Smalltalk garbageCollect].

	aClass := self newClassOrTrait.
	aClass compileSilently: 'foo ^ 42'.
	aClassSubclass := self newClassOrTraitSubclassOf: aClass.
	
	aClassCopy	:= aClass veryDeepCopy.

	self swapOutClass: aClass.
	3 timesRepeat: [Smalltalk garbageCollect].
	self assert: aClass mareaIsProxy. 
	
	self swapIn: aClassSubclass.	
	3 timesRepeat: [Smalltalk garbageCollect].

	self deny: aClass mareaIsProxy. 
	self assert: aClass name equals: aClassCopy name.
	self assert: aClass methodDict equals: aClassCopy methodDict.
	self assert: aClass subclasses equals: aClassCopy subclasses.
	self assert: aClass format equals: aClassCopy format.
	self assert: aClassSubclass new foo equals: 42.
! !

!ObjectGraphSwapperTest methodsFor: 'tests class swapping' stamp: 'MarianoMartinezPeck 12/9/2011 16:21'!
testSwapOutClassWithSubclassSwapInBySubclassInstance

	| aClass aClassCopy aClassSubclass aSubclassInstance |

	3 timesRepeat: [Smalltalk garbageCollect].

	aClass := self newClassOrTrait.
	aClass compileSilently: 'foo ^ 42'.
	aClassSubclass := self newClassOrTraitSubclassOf: aClass.
	aSubclassInstance := aClassSubclass new. 
	
	aClassCopy	:= aClass veryDeepCopy.

	self swapOutClass: aClass.
	3 timesRepeat: [Smalltalk garbageCollect].
	self assert: aClass mareaIsProxy. 
	
	self swapIn: aSubclassInstance.	
	3 timesRepeat: [Smalltalk garbageCollect].

	self deny: aClass mareaIsProxy. 
	self assert: aClass name equals: aClassCopy name.
	self assert: aClass methodDict equals: aClassCopy methodDict.
	self assert: aClass subclasses equals: aClassCopy subclasses.
	self assert: aClass format equals: aClassCopy format.
	self assert: aSubclassInstance foo equals: 42.
! !

!ObjectGraphSwapperTest methodsFor: 'tests class swapping' stamp: 'MarianoMartinezPeck 12/9/2011 16:23'!
testSwapOutClassWithSubclassSwapInBySubclassMetaclass

	| aClass aClassCopy aClassSubclass aClassSubclassMetaclass |

	3 timesRepeat: [Smalltalk garbageCollect].

	aClass := self newClassOrTrait.
	aClass compileSilently: 'foo ^ 42'.
	aClassSubclass := self newClassOrTraitSubclassOf: aClass.
	aClassSubclassMetaclass := aClassSubclass class.
	
	aClassCopy	:= aClass veryDeepCopy.

	self swapOutClass: aClass.
	3 timesRepeat: [Smalltalk garbageCollect].
	self assert: aClass mareaIsProxy. 
	
	self swapIn: aClassSubclassMetaclass.	
	3 timesRepeat: [Smalltalk garbageCollect].

	self deny: aClass mareaIsProxy. 
	self assert: aClass name equals: aClassCopy name.
	self assert: aClass methodDict equals: aClassCopy methodDict.
	self assert: aClass subclasses equals: aClassCopy subclasses.
	self assert: aClass format equals: aClassCopy format.
	self assert: aClassSubclass new foo equals: 42.
! !

!ObjectGraphSwapperTest methodsFor: 'tests method swapping' stamp: 'MarianoMartinezPeck 12/9/2011 00:06'!
testSwapOutCompiledMethodsAndExecuteIt
	|  instance |

	instance := ClassWith1Var new. 
	ObjectGraphSwapper new swapOutGraph: (ClassWith1Var>>#foo)..
	self assert: instance foo = 'foo' 
	! !

!ObjectGraphSwapperTest methodsFor: 'tests class swapping' stamp: 'MarianoMartinezPeck 12/9/2011 00:05'!
testSwapOutExistingClassSwapInByClass

	| aClass aClassCopy |

	3 timesRepeat: [Smalltalk garbageCollect].

	aClass := AbstractAutotestTestLongRun.
	aClassCopy	:= aClass veryDeepCopy.

	self swapOutClass: aClass.
	3 timesRepeat: [Smalltalk garbageCollect].
	self assert: aClass mareaIsProxy. 
	
	self swapIn: aClass.	
	3 timesRepeat: [Smalltalk garbageCollect].

	self deny: aClass mareaIsProxy. 
	self assert: aClass name equals: aClassCopy name.
	self assert: aClass methodDict equals: aClassCopy methodDict.
	self assert: aClass subclasses equals: aClassCopy subclasses.
	self assert: aClass format equals: aClassCopy format.
! !

!ObjectGraphSwapperTest methodsFor: 'tests basic' stamp: 'MarianoMartinezPeck 9/29/2011 14:31'!
testUninstallFromRootNoIntersection
	"This tests that a graph is loaded back when the ROOT receives a message and when there is NO intersection probem, that is, there is no swapping of external graphs that refer to our facade objects."
	| a b proxiesCount |
	
	3 timesRepeat: [Smalltalk garbageCollect].
	proxiesCount := self proxyClass instanceCount.
	
	a := ClassWith2Var new.
	b := ClassWith1Var new. 
	"Do not put a string or something like that because otherwise it is stored in the literals of the method and hence it is considered as a shared object"
	b var1: 6.
	a var1: (Point x: 4 y: 2).
	a var2: b.
	
	self swapOut: a.
	3 timesRepeat: [Smalltalk garbageCollect].
	self swapIn: a.
	3 timesRepeat: [Smalltalk garbageCollect].
	self assert: self proxyClass instanceCount equals: proxiesCount.
	self assert: b == a var2.
	self assert: b var1 equals: 6.
	self assert: a var1 equals: 4@2.
	! !

!ObjectGraphSwapperTest methodsFor: 'tests basic' stamp: 'MarianoMartinezPeck 9/29/2011 14:31'!
testUninstallFromSharedObjectNoIntersection
	"This tests that a graph is loaded back when a facade object receives a message and when there is NO intersection probem, that is, there is no swapping of external graphs that refer to our facade objects."
	| a b proxiesCount |
	
	3 timesRepeat: [Smalltalk garbageCollect].
	proxiesCount := self proxyClass instanceCount.
	
	a := ClassWith2Var new.
	b := ClassWith1Var new. 
	"Do not put a string or something like that because otherwise it is stored in the literals of the method and hence it is considered as a shared object"
	b var1: 6.
	a var1: (Point x: 4 y: 2).
	a var2: b.

	self swapOut: a.
	3 timesRepeat: [Smalltalk garbageCollect].
	self swapIn: b.
	3 timesRepeat: [Smalltalk garbageCollect].
	self assert: self proxyClass instanceCount equals: proxiesCount.
	self assert: b == a var2.
	self assert: b var1 equals: 6.
	self assert: a var1 equals: 4@2.! !

!ObjectGraphSwapperTest methodsFor: 'tests pending' stamp: 'MarianoMartinezPeck 9/14/2011 21:09'!
xtestRootObjectNotAnymoreNoIntersection2
	"This tests that a graph is loaded back when a facade object receives a message and when there is NO intersection probem, that is, there is no swapping of external graphs that refer to our facade objects. In addition, it tests that the root object to which we have created a proxy, is garbage collected because nobody else point to it. "
	| a b proxiesCount |
	
	3 timesRepeat: [Smalltalk garbageCollect].
	proxiesCount := MareaProxyMock instanceCount.
	
	a := ClassWith2Var new.
	b := ClassWith1Var new. 
	b var1: 'nose'.
	a var1: Date today.
	a var2: b.

	ObjectGraphSwapper new swapOutGraph: a.
	3 timesRepeat: [Smalltalk garbageCollect].
	
	"Now lets say that nobody else point to the root object A"	
	self assert: MareaProxyMock instanceCount equals: proxiesCount + 2.
	a := nil.
	3 timesRepeat: [Smalltalk garbageCollect].
	self assert: MareaProxyMock instanceCount equals: proxiesCount + 1.
	
	ObjectGraphSwapper new swapInGraphFor: b.
	3 timesRepeat: [Smalltalk garbageCollect].
	self assert: MareaProxyMock instanceCount equals: proxiesCount.
	self assert: b var1 equals: 'nose'.
! !

IdentitySet subclass: #ProxiesIdentitySet
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Marea-Collections'!

!ProxiesIdentitySet methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/4/2011 15:23'!
asProxiesIdentitySet
	^self! !

!ProxiesIdentitySet methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/4/2011 15:23'!
scanFor: anObject
	"Scan the key array for the first slot containing either a nil (indicating an empty slot) or an element that matches anObject. Answer the index of that slot or zero if no slot is found. This method will be overridden in various subclasses that have different interpretations for matching elements."

	| index start hash |
	hash := anObject mareaIdentityHash.
	index := start := hash \\ array size + 1.
	[ 
		| element |
		((element := array at: index) == nil or: [ element enclosedSetElement == anObject ])
			ifTrue: [ ^index ].
		(index := index \\ array size + 1) = start ] whileFalse.
	self errorNoFreeSpace! !

!ProxiesIdentitySet methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/4/2011 15:24'!
scanForEmptySlotFor: aKey
	"Scan the key array for the first slot containing an empty slot (indicated by a nil). Answer the index of that slot. This method will be overridden in various subclasses that have different interpretations for matching elements."
	
	| index start |
	index := start := aKey mareaIdentityHash \\ array size + 1.
	[ 
		(array at: index) ifNil: [ ^index ].
		(index := index \\ array size + 1) = start ] whileFalse.
	self errorNoFreeSpace! !

!SmalltalkImage methodsFor: '*Marea' stamp: 'MarianoMartinezPeck 12/9/2011 17:43'!
mareaAllClassesAndTraitsWithoutProxiesDo: aBlock
	^globals mareaAllClassesAndTraitsWithoutProxiesDo: aBlock! !

IdentityDictionary subclass: #ProxiesIdentityDictionary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Marea-Collections'!

!ProxiesIdentityDictionary methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/4/2011 14:59'!
scanFor: anObject
	"Scan the key array for the first slot containing either a nil (indicating an empty slot) or an element that matches anObject. Answer the index of that slot or zero if no slot is found. This method will be overridden in various subclasses that have different interpretations for matching elements."
	| finish start element |
	finish := array size.
	start := (anObject mareaIdentityHash \\ finish) + 1.

	"Search from (hash mod size) to the end."
	start to: finish do:
		[:index | ((element := array at: index) == nil or: [element key == anObject])
			ifTrue: [^ index ]].

	"Search from 1 to where we started."
	1 to: start-1 do:
		[:index | ((element := array at: index) == nil or: [element key == anObject])
			ifTrue: [^ index ]].

	^ 0  "No match AND no empty slot"! !

!ProxiesIdentityDictionary methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/4/2011 14:59'!
scanForEmptySlotFor: aKey
	"Scan the key array for the first slot containing an empty slot (indicated by a nil). Answer the index of that slot. This method will be overridden in various subclasses that have different interpretations for matching elements."
	
	| index start |
	index := start := aKey mareaIdentityHash \\ array size + 1.
	[ 
		(array at: index) ifNil: [ ^index ].
		(index := index \\ array size + 1) = start ] whileFalse.
	self errorNoFreeSpace! !

Object subclass: #AbstractMareaSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Marea-Serializers'!

!AbstractMareaSerializer methodsFor: 'API' stamp: 'MarianoMartinezPeck 12/12/2011 10:54'!
materializeObjectFrom: aFileName
	self shouldBeImplemented ! !

!AbstractMareaSerializer methodsFor: 'API' stamp: 'MarianoMartinezPeck 4/1/2011 16:11'!
serializeAndWriteObject: anObject to: aFileName
	self shouldBeImplemented ! !

AbstractMareaSerializer subclass: #FuelMareaSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Marea-Serializers'!

FuelMareaSerializer subclass: #FuelCachedMareaSerializer
	instanceVariableNames: 'cachedAnalyzer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Marea-Serializers'!

!FuelCachedMareaSerializer class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/30/2011 12:09'!
newDefault
	^ self new cachedAnalyzer: FLMareaAnalyzer newDefault! !

!FuelCachedMareaSerializer methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 7/6/2011 11:48'!
cachedAnalyzer
	^ cachedAnalyzer! !

!FuelCachedMareaSerializer methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 7/6/2011 11:48'!
cachedAnalyzer: anObject
	cachedAnalyzer := anObject! !

!FuelCachedMareaSerializer methodsFor: 'reset' stamp: 'MarianoMartinezPeck 11/30/2011 14:17'!
resetedCachedAnalyzer
	^ self cachedAnalyzer reset
	! !

!FuelCachedMareaSerializer methodsFor: 'reset' stamp: 'MarianoMartinezPeck 7/6/2011 14:48'!
resetedCachedAnalyzerWithInternalObjects: aCollection
	^ self cachedAnalyzer resetWithInternalObjects: aCollection
	! !

!FuelCachedMareaSerializer methodsFor: 'read - write' stamp: 'MarianoMartinezPeck 7/12/2011 13:31'!
serializeAndWriteClass: aClass to: aFileName
| serializer aFileStream |
      aFileStream := (StandardFileStream fileNamed: aFileName) binary.
      serializer := FLSerializer on: aFileStream.
	serializer 
		serialize: aClass 
		analyzer: (self resetedCachedAnalyzerWithInternalObjects: (Array with: aClass)).
      aFileStream close.
      self mareaLog: 'The class ', aClass name, ' was written on file'.! !

!FuelCachedMareaSerializer methodsFor: 'read - write' stamp: 'MarianoMartinezPeck 11/30/2011 12:07'!
serializeAndWriteObject: anObject to: aFileName
	| serialization aFileStream serializer proxyMapper | 
	aFileStream := (StandardFileStream fileNamed: aFileName) binary.
	serializer := FLSerializer newDefault analyzer: self resetedCachedAnalyzer.
	serializer mareaSerialization.
	serialization := serializer serialize: anObject on: aFileStream.
	aFileStream close.
	self mareaLog: 'The object ', anObject mareaBasicName, ' was written on file'.
	^ serialization! !

!FuelMareaSerializer class methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 11/30/2011 14:22'!
newDefault
	^ self new! !

!FuelMareaSerializer methodsFor: 'read - write' stamp: 'MarianoMartinezPeck 12/12/2011 10:58'!
materializeObjectFrom: aFileName
	| materialization aFileStream |
	aFileStream := (StandardFileStream fileNamed: aFileName) binary.
	materialization := FLMaterializer newDefault materializeFrom: aFileStream.
	aFileStream close.
	^ materialization root
! !

!FuelMareaSerializer methodsFor: 'read - write' stamp: 'MarianoMartinezPeck 12/12/2011 10:52'!
serializeAndWriteObject: anObject to: aFileName
	| serialization aFileStream serializer proxyMapper analyzer | 
	aFileStream := (StandardFileStream forceNewFileNamed: aFileName) binary.
	analyzer := FLMareaAnalyzer newDefault. 
	anObject mareaIsProxy ifFalse: [
		anObject isBehavior
			ifTrue: [ analyzer considerInternalAll: (Array with: anObject)]
		].
	serializer := FLSerializer newDefault analyzer: analyzer.
	analyzer considerGlobalWhenPossible.
	serializer mareaSerialization.
	serialization := serializer serialize: anObject on: aFileStream.
	aFileStream close.
	self mareaLog: 'The object ', anObject mareaBasicName, ' was written on file'.
	^ serialization! !

Object subclass: #ClassProxyInterceptor
	instanceVariableNames: ''
	classVariableNames: 'MutexProxy'
	poolDictionaries: ''
	category: 'Marea-Proxies'!

!ClassProxyInterceptor class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 12/8/2011 19:00'!
initialize
	MutexProxy := Mutex new.! !

!ClassProxyInterceptor methodsFor: 'intercepting' stamp: 'MarianoMartinezPeck 12/9/2011 16:47'!
cannotInterpret: aMessage
	| proxy context counter |

	MutexProxy critical: 
	[
	MareaLogger logger log:  'cannotInterpret:  ', aMessage selector.
	MareaLogger logger log:  'Stack:  '.
	MareaLogger logger log:  '----------------'.
		
	context := thisContext sender.
	counter := 0.
	[context isNil not and: [counter < 50]] whileTrue:  [
		MareaLogger logger log: context  method mareaPrintString.
		context := context sender.
		counter := counter + 1.
		].
	
	MareaLogger logger log:  '----------------'.

	"We first have to find the proxy, that is, we need to search in the hierarchy the first class (or proxy) whose methodDict is nil. Usually here I should be able todo 'aMessage lookupClass mareaFindClassWithNilMethodDictInHierarchy', but in this particular case, that would lead into a system crash when swapping out classes. As an example, I have have the class XXX and its subclass YYY. We swapped XXX and now YYY has received a message. The VM see that XXX has its methodDict in nil and sends #cannotInterpret:.  If here we do 'aMessage lookupClass mareaFindClassWithNilMethodDictInHierarchy' to YYY, it will loop, because it will find again that it superclass (XXX) has the methodDict in nil. So we CANNOT send any message here because it will be trap again. We need to avoid the method lookup. For that purpose, we directly evaluate the compiled method #mareaFindClassWithNilMethodDictInHierarchy in each class of the hierarchy until we find the proxy. It is not risky to use this compiledMethod because the instance variables 'methodDict' and 'superclass' won't change they place, hence the bytecode will always be correct for classes. 
	This problem is exactly the same we have in #updateMissingSharedProxiesFrom: materializedInstances filling: dict."
	proxy := CompiledMethod receiver: aMessage lookupClass withArgs: #() executeMethod: (Behavior >> #mareaFindClassWithNilMethodDictInHierarchy).
	^ ProxyHandler handleInterception: aMessage for: proxy receiver: self.	
	
	]! !

Object subclass: #ClassProxyMock
	instanceVariableNames: 'superclass methodDict format proxyID'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Marea-Swapping-Tests'!

!ClassProxyMock class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 12/7/2011 10:31'!
newProxyFor: anObject 
	^ self new! !

!ClassProxyMock methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 12/7/2011 10:55'!
initialize
	methodDict := MethodDictionary emptyMethodDictionary.! !

!ClassProxyMock methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 12/7/2011 10:31'!
mareaGraphID
	^ proxyID bitAnd: 2r111111111111111! !

!ClassProxyMock methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 12/7/2011 10:31'!
mareaIsProxy
	^ true! !

!ClassProxyMock methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 12/7/2011 10:31'!
mareaPosition
	^ proxyID >> 15 
	! !

!ClassProxyMock methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 12/7/2011 10:31'!
mareaProxyID
	^ proxyID! !

!ClassProxyMock methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 12/7/2011 10:31'!
mareaSetPosition: aPosition setGraphID: aGraphID
	proxyID :=  (aGraphID bitAnd: 16rFFFF) bitOr: (aPosition << 15).
! !

Object subclass: #CompiledMethodSwapper
	instanceVariableNames: ''
	classVariableNames: 'Logger ProxyClass'
	poolDictionaries: ''
	category: 'Marea-Swapping'!

!CompiledMethodSwapper class methodsFor: 'stuff to exclude' stamp: 'MarianoMartinezPeck 5/3/2011 17:44'!
classesNotToSwap

	| tooDangerousClasses coreClasses protoObjectSubclasses classesSpecialArray veryUsedClasses allClasses debuggingClasses nilSubclasses |

	"This are classes that are known as too dangerous."
	tooDangerousClasses := OrderedCollection new.
	(ClassBuilder new tooDangerousClasses) 
		do: [:each | Smalltalk globals at: each 
			ifPresent: [:present | tooDangerousClasses add: (Smalltalk at: each) ] 
			ifAbsent: []].
	
	"These classes because they are too core and used by the code to swapout itseld"
	coreClasses :=  {Array. Object. ProtoObject. Class. Message. MethodDictionary. CompiledMethod}. 

	"Subclasses of ProtoObject because they do not implement some methods that Object does and that are used by the swapping stuff."
	protoObjectSubclasses := ProtoObject subclasses.
	
	"These classes cannot be swapped because they are used by the VM"
	classesSpecialArray := Smalltalk specialObjectsArray select: [ :each | each isBehavior ].
	
	"These classes cannot be swapped because they install the segment (they are used) even before the segment can be written into a file"
	veryUsedClasses := { Cursor. CursorWithMask. EncodedCharSet.}.
	
	"Classes that are usually needed to debug and they help us to analyze problems"
	debuggingClasses := { DEVToolSet. }.
	
	"nil subclasses cannot be swapped out because since they don't subclass ProtoObject they may not even implement doesNotUnderstand:.
	For example, if we swap a CompiledMethod of PseudoContext, and then we try to load it back, the VM will crash with the error Recursive not understood error encountered. '"
	nilSubclasses := nil subclasses.
	
	allClasses := coreClasses, protoObjectSubclasses, classesSpecialArray, veryUsedClasses, tooDangerousClasses, debuggingClasses, nilSubclasses.
	
	^ allClasses asOrderedCollection ! !

!CompiledMethodSwapper class methodsFor: 'stuff to include' stamp: 'MarianoMartinezPeck 5/13/2011 10:28'!
compiledMethodsToSwap
	|  methodsToSwap classesNotToSwap packagesNotToSwap fixedMethodsNotToSwap |
	
	fixedMethodsNotToSwap := self fixedMethodsNotToSwap.
	
	UnusedObjectDiscoverer current startDiscovery. 

	self discoverMinimalUsedCompiledMethods.
	self methodsUsedByMareaTesting.
	
	packagesNotToSwap := self packagesNotToSwap.
	
	classesNotToSwap := self classesNotToSwap.
	packagesNotToSwap do: [:aPackage | classesNotToSwap addAll: aPackage classes ].
	packagesNotToSwap do: [:aPackage | fixedMethodsNotToSwap addAll: aPackage extensionMethods ].
	
	fixedMethodsNotToSwap do: [:aMethod | 	UnusedObjectDiscoverer current primitiveSetUsedBit: aMethod boolean: true].
	
	classesNotToSwap do: [:aClass | aClass markAllInstanceAndClassMethodsAsUsed].
	
	UnusedObjectDiscoverer current stopDiscovery.
	
	methodsToSwap := CompiledMethod unusedInstances.
	methodsToSwap := methodsToSwap reject: [:each | each isInstalled not ].
	
	Transcript show: 'Methods to swap: ',  methodsToSwap size asString; cr.
	Transcript show: 'Methods NOT to swap: ',  CompiledMethod usedInstances size asString; cr.
	
	^ methodsToSwap


! !

!CompiledMethodSwapper class methodsFor: 'stuff to exclude' stamp: 'MarianoMartinezPeck 11/27/2010 17:05'!
discoverMinimalUsedCompiledMethods
"These the minimal CompiledMethods needed to install and install a CompiledMethodProxy"
	| aProxy |
	
	SystemNavigation default browseClass: Object.
	
	aProxy := self installOn: ClassWith1Var selector: #foo.
	(ClassWith1Var methodDict at: #foo) literals.
	
	aProxy := self installOn: ClassWith1Var selector: #foo.
	ClassWith1Var new foo.! !

!CompiledMethodSwapper class methodsFor: 'examples' stamp: 'MarianoMartinezPeck 7/6/2011 11:39'!
exampleSwapOutAllUnusedMethods 
	"self exampleSwapOutAllUnusedMethods"
	| methodsToSwap timeToInstall timeToUninstall counter |
	"CompiledMethodProxyHandler mareaSerializer: FuelMareaSerializer. "
	CompiledMethodProxySwapperHandler serializer: FuelMareaSerializer new. 
	self proxyClass: NumberAsFilenameCompiledMethodProxySwapper.
	self proxyClass runningTest: false.
	self proxyClass mareaResetNumber.
	Logger := nil.
	"MareaLogger changeToFileLogger."
	MareaLogger disableLogging.
	3 timesRepeat: [Smalltalk garbageCollect].
	self log: 'Using proxy class: ', self proxyClass name.
	self log: 'Proxies installed instances before start: ', self proxyClass mareaAllInstalledProxiesCount asString.
	self log: 'CompiledMethod instances before start: ', CompiledMethod instanceCount asString.
	self log: 'Memory used before proxies: ', (Smalltalk vmParameterAt: 3) asString.
	"self printSpaceTally.
"	methodsToSwap := self compiledMethodsToSwap.
	self proxyClass: NumberAsFilenameCompiledMethodProxySwapper.
	self proxyClass runningTest: false.
	
	
	CompiledMethodProxySwapperHandler serializer: FuelMareaSerializer. 
	self log: 'CompiledMethods to swap: ',  methodsToSwap size asString.
	
	counter := 0.
	"[timeToInstall := MessageTally time: ["
	methodsToSwap do: [:method| 
		"(counter \\ 5000) isZero ifTrue: [
			self log: ''."
			"self log: SmalltalkImage current vmStatisticsReportString."
			"self log: ''."
		"]. 
		counter := counter + 1."
		"self log: 'Class: ', method methodClass name asString, ' selector: ', method selector asString. "
		self installOn: method methodClass selector: method selector.].
	"]."

	self log: 'Time to install proxies: ', timeToInstall asString, ' miliseconds'.
	methodsToSwap := nil.
	MCMethodDefinition shutDown. 
	3 timesRepeat: [Smalltalk garbageCollect].
	self log: 'Proxies intalled: ', self proxyClass mareaAllInstalledProxiesCount asString.
	self log: 'CompiledMethod instances after installing: ', CompiledMethod instanceCount asString.
	self log: 'Memory used using proxies: ', (Smalltalk vmParameterAt: 3) asString.

	[
"	timeToUninstall := MessageTally time: [
		counter := 0.
		self proxyClass mareaAllInstalledProxies do: [:instance| 
			(counter \\ 5000) isZero ifTrue: [
				self log: ''.
				self log: SmalltalkImage current vmStatisticsReportString.
				self log: ''.
				self printSpaceTally.
			]. 
		counter := counter + 1.
		instance mareaUninstallIfNeeded
		].		
	]."

	"self proxyClass mareaUninstallIfNeededAllInstances."
	self log: 'Time to uninstall proxies: ', timeToUninstall asString, ' miliseconds'.
	MCMethodDefinition shutDown. 
	3 timesRepeat: [Smalltalk garbageCollect].
	self log: 'Proxies installed instances after uninstalling: ', self proxyClass mareaAllInstalledProxiesCount asString.
	self log: 'Memory used after uninstalling proxies: ', (Smalltalk vmParameterAt: 3) asString.
	self log: 'CompiledMethod instances after uninstalling: ', CompiledMethod instanceCount asString.
	"self printSpaceTally."
	] ensure: [
		self log: 'Ensure....'.
		"self proxyClass mareaUninstallIfNeededAllInstances."
"		(FileDirectory default fileNamesMatching: '*.swap*') 
			do: [ :aFile | FileDirectory default deleteFileNamed: aFile ]."
	]! !

!CompiledMethodSwapper class methodsFor: 'examples' stamp: 'MarianoMartinezPeck 7/6/2011 11:39'!
exampleSwapOutAllUnusedMethodsAndClasses
	"self nose"
	| methodsToSwap timeToInstall timeToUninstall counter |
	"CompiledMethodProxyHandler mareaSerializer: FuelMareaSerializer. "
	CompiledMethodProxySwapperHandler serializer: FuelMareaSerializer new. 
	self proxyClass: NumberAsFilenameCompiledMethodProxySwapper.
	self proxyClass runningTest: false.
	self proxyClass mareaResetNumber.
	Logger := nil.
	MareaLogger disableLogging.
	3 timesRepeat: [Smalltalk garbageCollect].
	self log: 'Using proxy class: ', self proxyClass name.
	self log: 'Methods Proxies installed instances before start: ', self proxyClass mareaAllInstalledProxiesCount asString.
	self log: 'Class Proxies installed instances before start: ', ClassProxySwapper mareaAllInstalledProxiesCount asString.
	self log: 'CompiledMethod instances before start: ', CompiledMethod instanceCount asString.
	self log: 'Classes instances before start: ', Smalltalk allClassesAndTraits size asString.
	self log: 'Memory used before proxies: ', (Smalltalk vmParameterAt: 3) asString.
	"self printSpaceTally.
"	methodsToSwap := self compiledMethodsToSwap.
	
	CompiledMethodProxySwapperHandler serializer: FuelMareaSerializer. 
	self log: 'CompiledMethods to swap: ',  methodsToSwap size asString.
	
	counter := 0.
	[timeToInstall := MessageTally time: [
	methodsToSwap do: [:method| 
		(counter \\ 5000) isZero ifTrue: [
			self log: ''.
			"self log: SmalltalkImage current vmStatisticsReportString."
			self log: ''.
		]. 
		counter := counter + 1.
		self installOn: method methodClass selector: method selector.].
	].

	Smalltalk allClassesDo: [:aClass | aClass hasAllMethodsAsProxies ifTrue: [ClassProxySwapper installOn: aClass ]. ].

	self log: 'Time to install proxies: ', timeToInstall asString, ' miliseconds'.
	methodsToSwap := nil.
	MCMethodDefinition shutDown. 
	3 timesRepeat: [Smalltalk garbageCollect].
	self log: 'Methods Proxies intalled: ', self proxyClass mareaAllInstalledProxiesCount asString.
	self log: 'CompiledMethod instances after installing: ', CompiledMethod instanceCount asString.
	self log: 'Class Proxies intalled: ',  ClassProxySwapper  mareaAllInstalledProxiesCount asString.
	self log: 'Class instances after installing: ', Smalltalk allClassesAndTraits size asString.
	
	self log: 'Memory used using proxies: ', (Smalltalk vmParameterAt: 3) asString.

"	timeToUninstall := MessageTally time: [
		counter := 0.
		self proxyClass mareaAllInstalledProxies do: [:instance| 
			(counter \\ 5000) isZero ifTrue: [
				self log: ''.
				self log: SmalltalkImage current vmStatisticsReportString.
				self log: ''.
				self printSpaceTally.
			]. 
		counter := counter + 1.
		instance mareaUninstallIfNeeded
		].		
	]."
	self log: 'Time to uninstall proxies: ', timeToUninstall asString, ' miliseconds'.
	MCMethodDefinition shutDown. 
	3 timesRepeat: [Smalltalk garbageCollect].
	self log: 'Method Proxies installed instances after uninstalling: ', self proxyClass mareaAllInstalledProxiesCount asString.
	self log: 'Class Proxies installed instances after uninstalling: ', ClassProxySwapper  mareaAllInstalledProxiesCount asString.
	self log: 'Memory used after uninstalling proxies: ', (Smalltalk vmParameterAt: 3) asString.
	self log: 'CompiledMethod instances after uninstalling: ', CompiledMethod instanceCount asString.
	self log: 'Class instances after uninstalling: ', Smalltalk allClassesAndTraits size asString.
	"self printSpaceTally."
	] ensure: [
		self log: 'Ensure....'.
		MareaLogger changeToFileLogger.
		"self proxyClass mareaUninstallIfNeededAllInstances."
"		(FileDirectory default fileNamesMatching: '*.swap*') 
			do: [ :aFile | FileDirectory default deleteFileNamed: aFile ]."
	]! !

!CompiledMethodSwapper class methodsFor: 'examples' stamp: 'MarianoMartinezPeck 12/13/2011 09:45'!
exampleSwapOutClassesForSomePackages
	"self exampleSwapOutTestMethodsForOnePackage"
	| objectsToSwap timeToInstall timeToUninstall |
	self halt.
	MareaLogger changeToTranscriptLogger.

	self proxyClass: RegularObjectProxy.
	ObjectGraphSwapper resetGlobalTable.
	ObjectGraphSwapper resetGraphID.
	ObjectGraphSwapper resetSharedProxiesTable.  
	ObjectGraphSwapper proxyCreator: self proxyClass.
	
	self proxyClass runningTest: false.
	
	Logger := nil.
	MareaLogger disableLogging.
	3 timesRepeat: [Smalltalk garbageCollect].
	Symbol compactSymbolTable.
	self log: 'Proxies installed instances before start: ', self proxyClass mareaAllInstalledProxiesCount asString.
	self log: 'CompiledMethod instances before start: ', CompiledMethod instanceCount asString.
	self log: 'Memory used before proxies: ', (Smalltalk vmParameterAt: 3) asString.
	objectsToSwap := OrderedCollection new.
(PackageInfo allPackages select: [:each| each packageName includesSubString: 'AST-Tests'] ) do: [:aPackage |
		aPackage classes do: [:aClass |
			objectsToSwap addAll: aClass methods
			].
		].
	objectsToSwap  := objectsToSwap asIdentitySet asArray.
	self log: 'CompiledMethods to swap: ',  objectsToSwap size asString.
	[
	timeToInstall := MessageTally time: [
		self halt. objectsToSwap do: [:method| self swapOut: method].
	].
	self log: 'Time to install proxies: ', timeToInstall asString, ' miliseconds'.
	objectsToSwap := nil.
	MCMethodDefinition shutDown. 
	3 timesRepeat: [Smalltalk garbageCollect].
	self log: 'Proxies intalled: ', self proxyClass mareaAllInstalledProxiesCount asString.
	self log: 'CompiledMethod instances after installing: ', CompiledMethod instanceCount asString.
	Symbol compactSymbolTable.
	self log: 'Memory used using proxies after compacting symbol table: ', (Smalltalk vmParameterAt: 3) asString.
	self log: 'Memory used using proxies: ', (Smalltalk vmParameterAt: 3) asString.
	timeToUninstall := MessageTally time: [self proxyClass mareaUninstallIfNeededAllInstances].
	self log: 'Time to uninstall proxies: ', timeToUninstall asString, ' miliseconds'.
	MCMethodDefinition shutDown. 
	3 timesRepeat: [Smalltalk garbageCollect].
	self log: 'Proxies installed instances after uninstalling: ', self proxyClass mareaAllInstalledProxiesCount asString.
	self log: 'Memory used after uninstalling proxies: ', (Smalltalk vmParameterAt: 3) asString.
	self log: 'CompiledMethod instances after uninstalling: ', CompiledMethod instanceCount asString.
	] ensure: [
		self proxyClass mareaUninstallIfNeededAllInstances.
		(FileDirectory default fileNamesMatching: '*.swap*') 
			do: [ :aFile | FileDirectory default deleteFileNamed: aFile ].
	]! !

!CompiledMethodSwapper class methodsFor: 'examples' stamp: 'MarianoMartinezPeck 12/5/2011 10:27'!
exampleSwapOutTestMethodsForOnePackage
	"self exampleSwapOutTestMethodsForOnePackage"
	| objectsToSwap timeToInstall timeToUninstall |
	self halt.
	MareaLogger changeToTranscriptLogger.

	self proxyClass: RegularObjectProxy.
	ObjectGraphSwapper resetGlobalTable.
	ObjectGraphSwapper resetGraphID.
	ObjectGraphSwapper resetSharedProxiesTable.  
	ObjectGraphSwapper proxyCreator: self proxyClass.
	
	self proxyClass runningTest: false.
	
	Logger := nil.
	MareaLogger disableLogging.
	3 timesRepeat: [Smalltalk garbageCollect].
	Symbol compactSymbolTable.
	self log: 'Proxies installed instances before start: ', self proxyClass mareaAllInstalledProxiesCount asString.
	self log: 'CompiledMethod instances before start: ', CompiledMethod instanceCount asString.
	self log: 'Memory used before proxies: ', (Smalltalk vmParameterAt: 3) asString.
	objectsToSwap := OrderedCollection new.
(PackageInfo allPackages select: [:each| each packageName includesSubString: 'AST-Tests'] ) do: [:aPackage |
		aPackage classes do: [:aClass |
			objectsToSwap addAll: aClass methods
			].
		].
	objectsToSwap  := objectsToSwap asIdentitySet asArray.
	self log: 'CompiledMethods to swap: ',  objectsToSwap size asString.
	[
	timeToInstall := MessageTally time: [
		self halt. objectsToSwap do: [:method| self swapOut: method].
	].
	self log: 'Time to install proxies: ', timeToInstall asString, ' miliseconds'.
	objectsToSwap := nil.
	MCMethodDefinition shutDown. 
	3 timesRepeat: [Smalltalk garbageCollect].
	self log: 'Proxies intalled: ', self proxyClass mareaAllInstalledProxiesCount asString.
	self log: 'CompiledMethod instances after installing: ', CompiledMethod instanceCount asString.
	Symbol compactSymbolTable.
	self log: 'Memory used using proxies after compacting symbol table: ', (Smalltalk vmParameterAt: 3) asString.
	self log: 'Memory used using proxies: ', (Smalltalk vmParameterAt: 3) asString.
	timeToUninstall := MessageTally time: [self proxyClass mareaUninstallIfNeededAllInstances].
	self log: 'Time to uninstall proxies: ', timeToUninstall asString, ' miliseconds'.
	MCMethodDefinition shutDown. 
	3 timesRepeat: [Smalltalk garbageCollect].
	self log: 'Proxies installed instances after uninstalling: ', self proxyClass mareaAllInstalledProxiesCount asString.
	self log: 'Memory used after uninstalling proxies: ', (Smalltalk vmParameterAt: 3) asString.
	self log: 'CompiledMethod instances after uninstalling: ', CompiledMethod instanceCount asString.
	] ensure: [
		self proxyClass mareaUninstallIfNeededAllInstances.
		(FileDirectory default fileNamesMatching: '*.swap*') 
			do: [ :aFile | FileDirectory default deleteFileNamed: aFile ].
	]! !

!CompiledMethodSwapper class methodsFor: 'examples' stamp: 'MarianoMartinezPeck 12/2/2011 12:46'!
exampleSwapOutUnusedTestClasses
	"self exampleSwapOutUnusedTestClasses"
	| classesToSwap timeToInstall timeToUninstall |
	
	MareaLogger changeToTranscriptLogger.

	ObjectGraphSwapper resetGlobalTable.
	ObjectGraphSwapper resetGraphID.
	ObjectGraphSwapper resetSharedProxiesTable.  
	ObjectGraphSwapper proxyCreator: RegularObjectProxy.
	
	self proxyClass runningTest: false.

	Logger := nil.
	MareaLogger disableLogging.
	3 timesRepeat: [Smalltalk garbageCollect].
	Symbol compactSymbolTable.
	self log: 'Proxies installed instances before start: ', self proxyClass mareaAllInstalledProxiesCount asString.
	self log: 'Metaclass instances before start: ', Metaclass instanceCount asString.
	self log: 'Memory used before proxies: ', (Smalltalk vmParameterAt: 3) asString.
	classesToSwap := OrderedCollection new.
(PackageInfo allPackages select: [:each| each packageName includesSubString: 'Test'] ) do: [:aPackage |
		aPackage classes do: [:aClass | (UnusedObjectDiscoverer current primitiveGetUsedBit: aClass) 
			ifFalse: [classesToSwap add: aClass ]. 
			].
		].
	self log: 'Metaclasss to swap: ',  classesToSwap size asString.
	[
	timeToInstall := MessageTally time: [
	classesToSwap do: [:class| self installOn: class ].
	].
	self log: 'Time to install proxies: ', timeToInstall asString, ' miliseconds'.
	classesToSwap := nil.
	MCMethodDefinition shutDown. 
	3 timesRepeat: [Smalltalk garbageCollect].
	self log: 'Proxies intalled: ', self proxyClass mareaAllInstalledProxiesCount asString.
	self log: 'Metaclass instances after installing: ', Metaclass instanceCount asString.
	Symbol compactSymbolTable.
	self log: 'Memory used using proxies after compacting symbol table: ', (Smalltalk vmParameterAt: 3) asString.
	self log: 'Memory used using proxies: ', (Smalltalk vmParameterAt: 3) asString.
	timeToUninstall := MessageTally time: [self proxyClass mareaUninstallIfNeededAllInstances].
	self log: 'Time to uninstall proxies: ', timeToUninstall asString, ' miliseconds'.
	MCMethodDefinition shutDown. 
	3 timesRepeat: [Smalltalk garbageCollect].
	self log: 'Proxies installed instances after uninstalling: ', self proxyClass mareaAllInstalledProxiesCount asString.
	self log: 'Memory used after uninstalling proxies: ', (Smalltalk vmParameterAt: 3) asString.
	self log: 'Metaclass instances after uninstalling: ', Metaclass instanceCount asString.
	] ensure: [
		self proxyClass mareaUninstallIfNeededAllInstances.
		(FileDirectory default fileNamesMatching: '*.swap*') 
			do: [ :aFile | FileDirectory default deleteFileNamed: aFile ].
	]! !

!CompiledMethodSwapper class methodsFor: 'examples' stamp: 'MarianoMartinezPeck 12/2/2011 12:52'!
exampleSwapOutUnusedTestMethods
	"self exampleSwapOutUnusedTestMethods"
	| objectsToSwap timeToInstall timeToUninstall |
	
	MareaLogger changeToTranscriptLogger.

	ObjectGraphSwapper resetGlobalTable.
	ObjectGraphSwapper resetGraphID.
	ObjectGraphSwapper resetSharedProxiesTable.  
	ObjectGraphSwapper proxyCreator: RegularObjectProxy.
	
	self proxyClass runningTest: false.
	
	Logger := nil.
	MareaLogger disableLogging.
	3 timesRepeat: [Smalltalk garbageCollect].
	Symbol compactSymbolTable.
	self log: 'Proxies installed instances before start: ', self proxyClass mareaAllInstalledProxiesCount asString.
	self log: 'CompiledMethod instances before start: ', CompiledMethod instanceCount asString.
	self log: 'Memory used before proxies: ', (Smalltalk vmParameterAt: 3) asString.
	objectsToSwap := OrderedCollection new.
(PackageInfo allPackages select: [:each| each packageName includesSubString: 'Test'] ) do: [:aPackage |
		aPackage classes do: [:aClass |
			objectsToSwap addAll: aClass unusedMethods
			].
		].
	self log: 'CompiledMethods to swap: ',  objectsToSwap size asString.
	[
	timeToInstall := MessageTally time: [
	objectsToSwap do: [:method| self swapOut: method].
	].
	self log: 'Time to install proxies: ', timeToInstall asString, ' miliseconds'.
	objectsToSwap := nil.
	MCMethodDefinition shutDown. 
	3 timesRepeat: [Smalltalk garbageCollect].
	self log: 'Proxies intalled: ', self proxyClass mareaAllInstalledProxiesCount asString.
	self log: 'CompiledMethod instances after installing: ', CompiledMethod instanceCount asString.
	Symbol compactSymbolTable.
	self log: 'Memory used using proxies after compacting symbol table: ', (Smalltalk vmParameterAt: 3) asString.
	self log: 'Memory used using proxies: ', (Smalltalk vmParameterAt: 3) asString.
	timeToUninstall := MessageTally time: [self proxyClass mareaUninstallIfNeededAllInstances].
	self log: 'Time to uninstall proxies: ', timeToUninstall asString, ' miliseconds'.
	MCMethodDefinition shutDown. 
	3 timesRepeat: [Smalltalk garbageCollect].
	self log: 'Proxies installed instances after uninstalling: ', self proxyClass mareaAllInstalledProxiesCount asString.
	self log: 'Memory used after uninstalling proxies: ', (Smalltalk vmParameterAt: 3) asString.
	self log: 'CompiledMethod instances after uninstalling: ', CompiledMethod instanceCount asString.
	] ensure: [
		self proxyClass mareaUninstallIfNeededAllInstances.
		(FileDirectory default fileNamesMatching: '*.swap*') 
			do: [ :aFile | FileDirectory default deleteFileNamed: aFile ].
	]! !

!CompiledMethodSwapper class methodsFor: 'stuff to exclude' stamp: 'MarianoMartinezPeck 5/3/2011 18:00'!
fixedMethodsNotToSwap
	^ self selectorsNotToSwap
		inject: OrderedCollection new
		into: [:allMethods :aSelector | 
			allMethods addAll: 
				(CompiledMethod allInstances select: [:aMethod | aMethod selector = aSelector] ); yourself 
		]! !

!CompiledMethodSwapper class methodsFor: 'install' stamp: 'MarianoMartinezPeck 7/6/2011 15:39'!
installOn: aClass 
	^ self proxyClass installOn: aClass! !

!CompiledMethodSwapper class methodsFor: 'install' stamp: 'MarianoMartinezPeck 11/21/2010 16:27'!
installOn: aClass selector:  aSelector.
	^ self proxyClass installOn: aClass selector: aSelector.! !

!CompiledMethodSwapper class methodsFor: 'lists' stamp: 'MarianoMartinezPeck 11/21/2010 18:32'!
listOfCorePackages
	^ self listOfCorePackagesNames collect: [:each |  PackageInfo named: each ]! !

!CompiledMethodSwapper class methodsFor: 'lists' stamp: 'MarianoMartinezPeck 11/21/2010 18:32'!
listOfCorePackagesNames
	"To recreate this list, you can take a PharoCore image and print:
	PackageInfo allPackages collect: [:each| each packageName] 
"

	^  #('MultilingualTests' 'Morphic' 'ToolBuilder-Kernel' 'PackageInfo' 'Polymorph-ToolBuilder' 'Network-Kernel' 'Network-Protocols' 'Compiler' 'System-Finalization' 'Settings-Graphics' 'Collections' 'Network-RemoteDirectory' 'Traits' 'Network-URI' 'Settings-Display' 'Collections-Abstract' 'Settings-Compiler' 'MonticelloMocks' 'ScriptLoader11' 'System-Digital Signatures' 'System-Localization' 'MenuRegistration' 'Polymorph-TaskbarIcons' 'Monticello' 'ToolBuilder-Morphic' 'MCDirtyPackage' 'Collections-Weak' 'Settings-Polymorph' 'Tests' 'HelpSystem-Core-Utilities' 'SUnit' 'Collections-Text' 'Compression' 'Morphic-MorphTreeWidget' 'HelpSystem-Core' 'ToolsTest' 'Gofer-Core' 'Gofer-Tests' 'Collections-Stack' 'FreeType' 'MonticelloConfigurations' 'Polymorph-Geometry' 'Collections-Support' 'SUnitGUI' 'HelpSystem-Core-Model' 'Tests-VM' 'System-Change Notification' 'System' 'Tests-ObjectsAsMethods' 'HostMenus' 'Network-MIME' 'Network-RFC822' 'VB-Regex' 'TrueType' 'DeprecatedPreferences' 'System-Clipboard' 'System-Settings' 'MorphicTests' 'System-Serial Port' 'NetworkTests' 'Collections-Unordered' 'System-Changes' 'System-Object Storage' 'Collections-Traits' 'System-Platforms' 'Tests-PrimCallController' 'Morphic-TrueType' 'Multilingual' 'Graphics' 'Collections-Strings' 'KernelTests' 'System-FileRegistry' 'Tests-Bugs' 'ToolBuilder-SUnit' 'Tests-Release' 'Morphic-Balloon' 'Settings-Network' 'System-Applications' 'Polymorph-Tools-Diff' 'Settings-Tools' 'ScriptLoader' 'ST80' 'FreeTypeSubPixelAntiAliasing' 'Settings-Kernel' 'Settings-System' 'CompilerTests' 'System-Tools' 'System-Hashing' 'System-Download' 'Collections-Streams' 'Tests-SystemChangeNotification' 'GraphicsTests' 'Polymorph-Widgets' 'Kernel' 'Tools' 'Settings-FreeType' 'FreeTypeTests' 'Settings-Monticello' 'HelpSystem-Tests' 'Polymorph-EventEnhancements' 'System-Support' 'MonticelloGUI' 'System-FilePackage' 'System-Object Events' 'Announcements' 'System-Text' 'Exceptions' 'Network-UUID' 'System-Pools' 'FixUnderscores' 'HelpSystem-Core-UI' 'GraphicsResources' 'Files' 'Gofer' 'Network-MailSending' 'Collections-Arrayed' 'CollectionsTests' 'Balloon' 'Network-Url' 'Collections-Sequenceable')! !

!CompiledMethodSwapper class methodsFor: 'lists' stamp: 'MarianoMartinezPeck 11/21/2010 18:32'!
listOfNotDangerousCorePackages
	^ self listOfNotDangerousCorePackagesNames collect: [:each |  PackageInfo named: each ]! !

!CompiledMethodSwapper class methodsFor: 'lists' stamp: 'MarianoMartinezPeck 11/22/2010 21:40'!
listOfNotDangerousCorePackagesNames
	"To recreate this list, you can take a PharoCore image and print:
	PackageInfo allPackages collect: [:each| each packageName] 
"

	^ #('Morphic' 'ToolBuilder-Kernel' 'PackageInfo' 'Polymorph-ToolBuilder' 'Network-Kernel' 'Network-Protocols' 'Compiler' 'System-Finalization' 'Settings-Graphics' 'Collections' 'Network-RemoteDirectory' 'Traits' 'Network-URI' 'Settings-Display' 'Collections-Abstract' 'Settings-Compiler' 'MonticelloMocks' 'ScriptLoader11' 'System-Digital Signatures' 'System-Localization' 'MenuRegistration' 'Polymorph-TaskbarIcons' 'Monticello' 'ToolBuilder-Morphic' 'MCDirtyPackage' 'Collections-Weak' 'Settings-Polymorph' 'HelpSystem-Core-Utilities' 'SUnit' 'Collections-Text' 'Compression' 'Morphic-MorphTreeWidget' 'HelpSystem-Core' 'Gofer-Core' 'Collections-Stack' 'FreeType' 'MonticelloConfigurations' 'Polymorph-Geometry' 'Collections-Support' 'SUnitGUI' 'HelpSystem-Core-Model' 'System-Change Notification' 'System' 'HostMenus' 'Network-MIME' 'Network-RFC822' 'VB-Regex' 'TrueType' 'DeprecatedPreferences' 'System-Clipboard' 'System-Settings' 'System-Serial Port' 'Collections-Unordered' 'System-Changes' 'System-Object Storage' 'Collections-Traits' 'System-Platforms' 'Morphic-TrueType' 'Multilingual' 'Graphics' 'Collections-Strings' 'System-FileRegistry' 'ToolBuilder-SUnit' 'Morphic-Balloon' 'Settings-Network' 'System-Applications' 'Polymorph-Tools-Diff' 'Settings-Tools' 'ScriptLoader' 'ST80' 'FreeTypeSubPixelAntiAliasing' 'Settings-Kernel' 'Settings-System' 'System-Tools' 'System-Hashing' 'System-Download' 'Collections-Streams' 'Polymorph-Widgets' 'Kernel' 'Tools' 'Settings-FreeType' 'Settings-Monticello' 'Polymorph-EventEnhancements' 'System-Support' 'MonticelloGUI' 'System-FilePackage' 'System-Object Events' 'Announcements' 'System-Text' 'Exceptions' 'Network-UUID' 'System-Pools' 'FixUnderscores' 'HelpSystem-Core-UI' 'GraphicsResources' 'Files' 'Gofer' 'Network-MailSending' 'Collections-Arrayed' 'Balloon' 'Network-Url' 'Collections-Sequenceable')! !

!CompiledMethodSwapper class methodsFor: 'logging' stamp: 'MarianoMartinezPeck 11/30/2010 13:27'!
log: aString
	self logger log: aString ! !

!CompiledMethodSwapper class methodsFor: 'logging' stamp: 'MarianoMartinezPeck 11/30/2010 13:32'!
logger	
	Logger isNil ifTrue: [
		Logger := FixesFileNameLoggerStrategy named: 'Swapper.txt'.
		Logger startLogging].
	^ Logger! !

!CompiledMethodSwapper class methodsFor: 'stuff to exclude' stamp: 'MarianoMartinezPeck 11/30/2010 18:09'!
methodsUsedByMareaTesting
	| suite |
	suite := TestSuite named: 'zaraza'. 
	AbstractCompiledMethodProxyTest withAllSubclasses do: [:each |
		TestCase addTestsFor: each name toSuite: suite.].
	suite tests: (suite tests reject: [:each | each testSelector = #testCompiledMethodProxyAndGC]). 
	suite run. 
 ! !

!CompiledMethodSwapper class methodsFor: 'stuff to exclude' stamp: 'MarianoMartinezPeck 5/13/2011 13:58'!
packagesNotToSwap.
	"Notice that this is the strict way. If there are errors difficult to debug I would uncomment the commented ones and try."
	^ (# ("'System-Object Storage'" 'Fuel' 'Kernel' "'Graphics'" 'Exceptions' 'Proxies' "'Settings' ""'System'" 'UsedObject' "'Traits'" "'Balloon'" 'Tools-Base' "'Morphic'" "'ToolBuilder'" 'Compiler' ) collect: [:aPackageName | PackageInfo named: aPackageName]),
	(PackageInfo allPackages select: [:each | each packageName includesSubString: 'Collections-' ])
	
! !

!CompiledMethodSwapper class methodsFor: 'logging' stamp: 'MarianoMartinezPeck 12/2/2010 16:04'!
printSpaceTally
	self log: ''.
	self log: ''.
	SpaceTally new printSpaceAnalysis: 1 on: self logger logFile maxResults: 10. 
	self log: ''.
	self log: ''.! !

!CompiledMethodSwapper class methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 11/21/2010 16:24'!
proxyClass
	^ ProxyClass! !

!CompiledMethodSwapper class methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 11/21/2010 16:25'!
proxyClass: aProxyClass
	ProxyClass := aProxyClass.! !

!CompiledMethodSwapper class methodsFor: 'stuff to exclude' stamp: 'MarianoMartinezPeck 5/3/2011 18:06'!
selectorsNotToSwap
	^ #(#class #DoIt), (Smalltalk specialObjectsArray select: [:each | each isSymbol])
	
! !

!CompiledMethodSwapper class methodsFor: 'install' stamp: 'MarianoMartinezPeck 12/2/2011 13:09'!
swapOut: anObject
	ObjectGraphSwapper new swapOutGraph: anObject.
! !

Object subclass: #Interception
	instanceVariableNames: 'message receiver target proxy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Marea-Proxies'!

!Interception class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 4/21/2011 13:53'!
for: aMessage target: aTargetObject proxy: aProxy receiver: aReceiver
	^ self new initializewith: aMessage 
		target: aTargetObject
		proxy: aProxy 
		receiver: aReceiver ! !

!Interception methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 4/21/2011 13:39'!
initializewith: aMessage target: aTargetObject proxy: aProxy  receiver: aReceiver 
	message := aMessage.
	target := aTargetObject.
	proxy := aProxy.
	receiver := aReceiver.! !

!Interception methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/21/2011 13:52'!
message
	^ message! !

!Interception methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/21/2011 13:52'!
message: anObject
	message := anObject! !

!Interception methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/21/2011 13:52'!
proxy
	^ proxy! !

!Interception methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/21/2011 13:52'!
proxy: anObject
	proxy := anObject! !

!Interception methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/21/2011 13:52'!
receiver
	^ receiver! !

!Interception methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/21/2011 13:52'!
receiver: anObject
	receiver := anObject! !

!Interception methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/21/2011 13:52'!
target
	^ target! !

!Interception methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/21/2011 13:52'!
target: anObject
	target := anObject! !

Object subclass: #MareaLogger
	instanceVariableNames: ''
	classVariableNames: 'ProxiesLoggerHolder'
	poolDictionaries: ''
	category: 'Marea-Logging'!

!MareaLogger class methodsFor: 'change loggers' stamp: 'MarianoMartinezPeck 10/20/2010 15:27'!
changeToFileLogger
	"ProxiesLogger changeToFileLogger"
	^ self initialize! !

!MareaLogger class methodsFor: 'change loggers' stamp: 'MarianoMartinezPeck 10/20/2010 15:25'!
changeToTranscriptLogger
	| logger |
	logger := SimpleLogger new.
	logger strategy: TranscriptLoggerStrategy new. 
	logger startLogging.
	ProxiesLoggerHolder := logger.! !

!MareaLogger class methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 12/13/2011 12:30'!
createAndSetLogger
	ProxiesLoggerHolder := self createLogger.! !

!MareaLogger class methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 12/13/2011 12:30'!
createLogger
	| logger |
	logger := SimpleLogger new.
	logger strategy: (FixesFileNameLoggerStrategy named: 'Proxies.txt'). 
	logger startLogging.
	^ logger! !

!MareaLogger class methodsFor: 'change loggers' stamp: 'MarianoMartinezPeck 10/20/2010 15:28'!
disableLogging
	| logger |
	logger := SimpleLogger new.
	logger strategy: NullLoggerStrategy new. 
	logger startLogging.
	ProxiesLoggerHolder := logger.! !

!MareaLogger class methodsFor: 'examples' stamp: 'MarianoMartinezPeck 10/22/2010 17:23'!
example
	MyAppLogger logger mareaLog: 'zaraza'
	"Actually the idae is that you can create a method *MyAppLogger in Object that does:
	log: anObject
		MyAppLogger logger log: anObject
	
	So after, everywhere in your app you can just do self log: 'something'.
	"
	! !

!MareaLogger class methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 10/20/2010 17:08'!
initialize 
	ProxiesLoggerHolder := self createLogger.
	Smalltalk addToShutDownList: self.
	Smalltalk addToStartUpList: self.! !

!MareaLogger class methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/20/2010 15:15'!
logger
	ProxiesLoggerHolder
		ifNil: [ProxiesLoggerHolder := self createLogger].
	^ ProxiesLoggerHolder! !

!MareaLogger class methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 12/12/2011 21:50'!
shutDown
! !

!MareaLogger class methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 12/13/2011 11:00'!
startUp
! !

!MareaLogger methodsFor: 'seeClassSide' stamp: 'MarianoMartinezPeck 11/25/2010 17:16'!
seeClassSide ! !

Object subclass: #MareaProxyMock
	instanceVariableNames: 'proxyID'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Marea-Swapping-Tests'!

!MareaProxyMock class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 9/29/2011 14:50'!
newProxyFor: anObject 
	^ self new! !

!MareaProxyMock methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 9/16/2011 14:59'!
mareaGraphID
	^ proxyID bitAnd: 2r111111111111111! !

!MareaProxyMock methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 9/16/2011 10:46'!
mareaIsProxy
	^ true! !

!MareaProxyMock methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 9/16/2011 14:35'!
mareaPosition
	^ proxyID >> 15 
	! !

!MareaProxyMock methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 9/16/2011 14:38'!
mareaProxyID
	^ proxyID! !

!MareaProxyMock methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 9/16/2011 14:34'!
mareaSetPosition: aPosition setGraphID: aGraphID
	proxyID :=  (aGraphID bitAnd: 16rFFFF) bitOr: (aPosition << 15).
! !

!Object methodsFor: '*Marea' stamp: 'MarianoMartinezPeck 7/12/2011 13:35'!
mareaBasicName
	| title |
	title := self class name.
	^ String streamContents: [:aStream| 
		aStream
			nextPutAll: (title first isVowel ifTrue: ['an '] ifFalse: ['a ']);
			nextPutAll: title
		
	]
! !

!Object methodsFor: '*Marea' stamp: 'MarianoMartinezPeck 3/14/2011 19:42'!
mareaPrintString
	^ self printString! !

Object subclass: #ObjectGraphSwapper
	instanceVariableNames: ''
	classVariableNames: 'GraphTable IDGenerator Logger ProxyCreator SharedProxiesTable'
	poolDictionaries: ''
	category: 'Marea-Swapping'!

!ObjectGraphSwapper class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/4/2011 15:02'!
globalGraphTable
	GraphTable isNil ifTrue: [GraphTable := IdentityDictionary new].
	^ GraphTable! !

!ObjectGraphSwapper class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 9/19/2011 16:17'!
globalSharedProxiesTable
	SharedProxiesTable isNil ifTrue: [SharedProxiesTable := Dictionary new].
	^ SharedProxiesTable! !

!ObjectGraphSwapper class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 12/9/2011 16:49'!
newProxyFor: anObject
	^ ProxyCreator newProxy! !

!ObjectGraphSwapper class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 9/9/2011 11:27'!
nextGraphID
	IDGenerator isNil ifTrue: [IDGenerator := 0].
	IDGenerator := IDGenerator + 1.
	^ IDGenerator! !

!ObjectGraphSwapper class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 9/29/2011 14:48'!
proxyCreator: aProxyCreator
	ProxyCreator := aProxyCreator ! !

!ObjectGraphSwapper class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 9/9/2011 14:44'!
resetGlobalTable
	GraphTable := nil.! !

!ObjectGraphSwapper class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 9/9/2011 14:45'!
resetGraphID
	IDGenerator := nil.! !

!ObjectGraphSwapper class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 9/19/2011 15:21'!
resetSharedProxiesTable
	SharedProxiesTable := nil.! !

!ObjectGraphSwapper methodsFor: 'swap out' stamp: 'MarianoMartinezPeck 12/2/2011 10:31'!
becomeOriginalObjects: originalObjects toProxies: proxies

	"Finally, do a bulk become betwee the original objects and the proxies"
	originalObjects elementsForwardIdentityTo: proxies.
	self mareaLog: 'Original objects becomed proxies'.! !

!ObjectGraphSwapper methodsFor: 'swap out' stamp: 'MarianoMartinezPeck 12/9/2011 16:50'!
createClassProxyFor: aClass
	^ ClassProxy  newProxy! !

!ObjectGraphSwapper methodsFor: 'swap out' stamp: 'MarianoMartinezPeck 12/9/2011 16:56'!
createProxyFor: anObject
	^ self class newProxyFor: anObject! !

!ObjectGraphSwapper methodsFor: 'private' stamp: 'MarianoMartinezPeck 12/1/2011 12:02'!
fileNameFrom: graphID
	^ graphID asString, '.swap'! !

!ObjectGraphSwapper methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 9/9/2011 11:59'!
globalGraphTable
	^ self class globalGraphTable! !

!ObjectGraphSwapper methodsFor: 'swap in' stamp: 'MarianoMartinezPeck 12/2/2011 16:41'!
materializeFromFileNamed: graphIDString
	
	"We get the ID and we search a file named as the ID. Then we materialize it."
	| stream materializedInstances |
	stream := FileDirectory default oldFileOrNoneNamed: graphIDString.
	stream isNil
		ifTrue: [ self error: 'File does not exist']
		ifFalse: [ 
			materializedInstances := (FLMaterializer newDefault materializeFrom: stream binary) materializedInstances.
			stream close.
			^ materializedInstances
		]! !

!ObjectGraphSwapper methodsFor: 'swap out' stamp: 'MarianoMartinezPeck 11/30/2011 11:44'!
nextAvailableID
	^ self class nextGraphID ! !

!ObjectGraphSwapper methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 9/13/2011 11:15'!
originalObjectsAbleToBecome: originalObjects! !

!ObjectGraphSwapper methodsFor: 'swap out' stamp: 'MarianoMartinezPeck 12/1/2011 11:58'!
serialize: anObject toFileNamed: graphIDString
	
	"We serialize the graph and we answer the serialization object"
	^ FuelMareaSerializer newDefault serializeAndWriteObject: anObject to: graphIDString.! !

!ObjectGraphSwapper methodsFor: 'swap out' stamp: 'MarianoMartinezPeck 12/12/2011 21:07'!
shouldCreateProxyFor: anObject
	self flag: #todo.
	"I should really clean this list or at least understand which each of the lines is needed."
	(anObject class = SmallInteger) ifTrue: [^ false].
	(Smalltalk specialObjectsArray identityIncludes: anObject) ifTrue: [^ false].
	(anObject isBehavior or: [anObject isTrait]) ifTrue: [^ false].
	(anObject == Smalltalk globals) ifTrue: [^ false].
	(FLGlobalMapper defaultGlobals identityIncludes: anObject) ifTrue: [^ false].
	(anObject isSymbol) ifTrue: [^ false].
	"Actually, I should check if it is an Association in Smalltalk globals or in ClassPools" 
	(anObject isVariableBinding) ifTrue: [ ^ false ].
	(anObject isCharacter) ifTrue: [^ false]. 
	(anObject isString) ifTrue: [^ false]. 
	(anObject isCollection and: [anObject isEmpty]) ifTrue: [^ false]. 
	^ true
	 
! !

!ObjectGraphSwapper methodsFor: 'swap in' stamp: 'MarianoMartinezPeck 12/13/2011 15:07'!
swapInGraphFor: aProxy
	"So....a proxy has received a message and hence it needs to be uninstalled: it has to read the file from disc, materialize back the original graph and to the become back between all the proxies of the graph and the just materialized objects "

	| graphID dict materializedInstances |
	
	self mareaLog: 'Starting to swap in a graph.'.
	
	"We get the ID and we search a file named as the ID. Then we materialize it."	
	graphID := aProxy mareaGraphID.
	materializedInstances := self materializeFromFileNamed: (self fileNameFrom: graphID).
	self mareaLog: 'The graph was materialized from file named: ', (self fileNameFrom: graphID).
	
	 "Now we need to become all the proxies of the graph to the new materialized objects"
	dict := ProxiesIdentityDictionary new.
	self updateProxiesOfGraph: graphID withMaterializedInstances: materializedInstances filling: dict.
	self updateMissingSharedProxiesFrom: materializedInstances filling: dict.	
	self mareaLog: 'Proxies were updated'.	
	dict keys elementsForwardIdentityTo: dict values.	
	self mareaLog: 'Proxies becomed materialized objects'.
	
	"Finally we clean the global table. It may happen that several proxies of the same graph have received a message and both are trying to swap in. Hence, it may happen that at this time, there is no entry in the table for this graphID, meaning the graph has already been swapped in. In such a case, there is nothign else to do."
	self globalGraphTable removeKey: graphID ifAbsent: [  ].
	
	"Once everything was done sucessfully we remove the file"
	FileDirectory default deleteFileNamed: (self fileNameFrom: graphID).
	
	self mareaLog: 'Swap in finalized.'.
	
	"We need to answer the original object which was becomed with aProxy. But since it was become, the instVar aProxy is the correct one."
	^ aProxy
	! !

!ObjectGraphSwapper methodsFor: 'swap out' stamp: 'MarianoMartinezPeck 12/12/2011 21:07'!
swapOutClass: aClass
	| dict  graphID serialization |

	self mareaLog: 'Starting to swap out graph.'.
	graphID := self nextAvailableID.
	serialization := self serialize: aClass toFileNamed: (self fileNameFrom: graphID).
	self mareaLog: 'The graph was serialized to file named: ', (self fileNameFrom: graphID).
	dict := self traverseGraphAndCreateProxiesForSerializedObjects: serialization objectsIndexes.
	dict at: aClass put: (self createClassProxyFor: aClass).
	dict at: aClass class put: (self createClassProxyFor: aClass class).
	
	self updateProxiesPositionAndGraphID: dict serializedInstances: serialization objectsIndexes graphID: graphID.

	self becomeOriginalObjects: dict keys toProxies: dict values.
	self updateGlobalGraphTableWith: dict values graphID: graphID.

	dict := nil.
	serialization := nil.
	
	"At this moment, having done the bulk become and set the dict to nil, there are several objects that can be garbage collected: ALL original objects of the graph, no matter whether they are inner or shared. And ALL proxies that were associated with inner objects. The only proxies that are reachable, hence not garbage collected, are the proxy for the root of the graph, and the proxies for facade objects. Of course, notice that the whole object memory graph can change, and for example, it may happen that nobody else point to the root (now proxy) of the graph or to facade objects. If that happens, then those proxies are garbage collected as well "
	
	self flag: #todo.
	"This is needed becasuse some crashes happens when swapping out classes. "
	Smalltalk garbageCollect.! !

!ObjectGraphSwapper methodsFor: 'swap out' stamp: 'MarianoMartinezPeck 12/5/2011 13:12'!
swapOutGraph: anObject
	| dict  graphID serialization |

	self mareaLog: 'Starting to swap out graph.'.
	graphID := self nextAvailableID.
	serialization := self serialize: anObject toFileNamed: (self fileNameFrom: graphID).
	self mareaLog: 'The graph was serialized to file named: ', (self fileNameFrom: graphID).
	dict := self traverseGraphAndCreateProxiesForSerializedObjects: serialization objectsIndexes.
	self updateProxiesPositionAndGraphID: dict serializedInstances: serialization objectsIndexes graphID: graphID.

	self becomeOriginalObjects: dict keys toProxies: dict values.
	self updateGlobalGraphTableWith: dict values graphID: graphID.

	dict := nil.
	serialization := nil.
	
	"At this moment, having done the bulk become and set the dict to nil, there are several objects that can be garbage collected: ALL original objects of the graph, no matter whether they are inner or shared. And ALL proxies that were associated with inner objects. The only proxies that are reachable, hence not garbage collected, are the proxy for the root of the graph, and the proxies for facade objects. Of course, notice that the whole object memory graph can change, and for example, it may happen that nobody else point to the root (now proxy) of the graph or to facade objects. If that happens, then those proxies are garbage collected as well "
	
	self mareaLog: 'Swap out finalized.'.! !

!ObjectGraphSwapper methodsFor: 'swap out' stamp: 'MarianoMartinezPeck 12/2/2011 10:29'!
traverseGraphAndCreateProxiesForSerializedObjects:  objectsIndexes
	"We traverse the graph and, for each object, we create a proxy for it. Traversing the original object graph can be complicated because we need to take into account global objects like Smalltalk globals so that to avoid traversing almost all image. Fuel already deals with that problem, hence we can use the serialized instances by Fuel, that is, objectsIndexes. 
	They are added to an IdentityDictionary. Each key of the dict is an original object of the graph. The value associated with each key, is the proxy created for that object. If we find a proxy as part of the graph, we do not create a proxy for the proxy, but instead, we directly use the same proxy instance. Notice that it is common to find proxies inside the graph to swap out. This happens with objects that are shared between graphs and some of thise graphs were already swapped out.
	Notice that in this case we reusing the traversal of the serializer, and not  traversing the whole original graph. This has two problems:
	- The serializer also traverse objects outside the graph, for example, the classes of the objects we serialize. See #shouldCreateProxyFor: for more details.
	- The serializer does some optimization for certain classes, like Time, Date, etc, where it does NOT traverse all its instance variables, but instead it just serialize a number that represents it. Hence, we are not really traversing the whole graph. For this aspect, it is even better to do this instead of traversing the orignal graph. Becauese we have be creating a proxy that we will not be able to retrieve back the original object to which we should do the become, because the original object was not even serialized in the stream. "
	| proxiesDict |
	proxiesDict := ProxiesIdentityDictionary new.
	objectsIndexes keysDo: [:anObject | 
	"We traverse the graph and, for each object, we create a proxy for it. They are added to an IdentityDictionary. Each key of the dict is an original object of the graph. The value associated with each key, is the proxy created for that object. If we find a proxy as part of the graph, we do not create a proxy for the proxy, but instead, we directly use the same proxy instance. Moreever, in this case, we need to add this shared proxy in a table which is non-weak in order to not loose shared proxies. 
	Notice that it is common to find proxies inside the graph to swap out. This happens with objects that are shared between graphs and some of thise graphs were already swapped out.
	Finally, there are objects that cannot be #becomed like SmallIntegers. Hence we must avoid them. "
		(anObject mareaIsProxy)
			ifTrue: [ 
				proxiesDict at: anObject put: anObject.
				ObjectGraphSwapper globalSharedProxiesTable at: anObject mareaProxyID ifAbsentPut: [anObject].
				 ]
			ifFalse: [
				(self shouldCreateProxyFor: anObject)   
					ifTrue: [ proxiesDict at: anObject put: (self createProxyFor: anObject)]].	
			].
	
	self mareaLog: 'The graph was traversed and proxies were created'.
	^ proxiesDict! !

!ObjectGraphSwapper methodsFor: 'swap out' stamp: 'MarianoMartinezPeck 9/20/2011 11:28'!
updateGlobalGraphTableWith: proxies graphID: graphID.
	
	"There is a global table that keeps an entry per swapped graph. It is important to know which proxies there are for a certain graph, because when a proxy receives a message and it needs to load back the graph, it needs to known all the rest of the proxies that need the become as well. Hence, we keep a weak list of the proxies of the graph "
	self globalGraphTable at: graphID put: (WeakArray withAll: proxies).
! !

!ObjectGraphSwapper methodsFor: 'swap in' stamp: 'MarianoMartinezPeck 12/9/2011 16:38'!
updateMissingSharedProxiesFrom: materializedInstances filling: dict.	
		
	"So far we have only updated the proxies which were in the proxies array of the graph. However, there can be still some proxies we need to update. We can have the following situation:
	- A graph AAA has a shared object BBB with graph CCC.
	- Graph AAA is swapped out and then CCC is swapped out. When CCC is serialized, it will serialize the proxy PB for BBB.
	- Graph AAA is swapped in.
	Now, when CCC is swapped in, in the proxies table, the reference which used to point to the proxy PB, now points to the real object B. However, we still need to update the reference from the graph C. So we need to iterate to the just materialized instances and see whether we have proxies that we need to update"
	
	materializedInstances do: [:each |
		"Usually here I should be able todo 'each mareaIsProxy', but in this particular case, that would lead into a system crash when swapping out classes. As an example, I have have the class XXX and its subclass YYY. We swapped XXX and now YYY has received a message. The VM see that XXX has its methodDict in nil and sends #cannotInterpret:. When we now materialize XXX, in the 'materializedInstances' there will be pointers to its subclasses, in this example, YYY. If here we do 'each mareaIsProxy' to YYY, it will loop, because it will find again that it superclass (XXX) has the methodDict in nil. So we CANNOT send any message here because it will be trap again. To avoid that, we use #mareaClass which uses the specific bytecode which means that the method is not executed. Then we put #mareaIsProxy also in class side."
		each mareaClass mareaIsProxy ifTrue: [
			self class globalSharedProxiesTable 
				at: each mareaProxyID
				ifPresent: [:sharedProxy |
					"We become the proxy with whatever is in the table: a proxy or the target object. If it is a proxy, we just update the reference so that we point to the same proxy. If it is not a proxy, it means that the original object was already becomed because the original graph of such obejct was swapped in. In this case, again, we become the proxy to that object."
					dict at: each put: sharedProxy.
					] ].
		].	
! !

!ObjectGraphSwapper methodsFor: 'swap in' stamp: 'MarianoMartinezPeck 12/13/2011 15:07'!
updateProxiesOfGraph: graphID withMaterializedInstances: materializedInstances filling: dict

	| proxiesOfGraph |

	"It may happen that several proxies of the same graph have received a message and both are trying to swap in. Hence, it may happen that at this time, there is no entry in the table for this graphID, meaning the graph has already been swapped in. In such a case, there is nothign else to do."
	proxiesOfGraph := self globalGraphTable at: graphID ifAbsent: [ ^ self ].
	
	proxiesOfGraph do: [:each | 
		"Since this collection is weak, if it is nil it means it was a proxy for an object (inner or shared) which was finally garbage collected. There is nothing to do in that case. The same happens if the object is not nil, but it is a regular object (not a proxy). In this case, it should be a regular object which has been become from a previous proxy. Again, nothing to be done here. It is only necessary to do something when the object is a proxy.
		In addition, we may have put a proxy which was shared with another graph. Hence it may happen that such proxy was already uninstalled."
		each mareaIsProxy ifTrue: [  
			self class globalSharedProxiesTable 
				at: each mareaProxyID
				ifPresent: [:sharedProxy |
					"sharedProxy can be a proxy or the real object in case it was already uninstalled."
					(sharedProxy mareaGraphID == graphID)
						ifTrue: ["If the target object of such proxy was serialized with current graph we are swapping in, then we become the proxy with the original object." 
							dict at: each put: (materializedInstances at: each mareaPosition)]
						ifFalse: [ "If the target object of such proxy was serialized with ANOTHER graph we are swapping in, then we become the proxy with whatever is in the table: a proxy or the target object. If it is a proxy, we just update the reference so that we point to the same proxy. If it is not a proxy, it means that the original object was already becomed because the original graph of such obejct was swapped in. In this case, again, we become the proxy to that object.."
							dict at: each put: sharedProxy].
					]
				ifAbsent: [ "It means it was a regular proxy which was not shared with other graphs. Hence, we become the proxy to the original object"
					dict at: each put: (materializedInstances at: each mareaPosition)].	
			].
		].
	! !

!ObjectGraphSwapper methodsFor: 'swap out' stamp: 'MarianoMartinezPeck 12/2/2011 10:30'!
updateProxiesPositionAndGraphID: dict serializedInstances: serializedInstances graphID: graphID.
	
	"Now that the graph was serialized, I need to set to each proxy, its associated relative offset in the stream. This is necessary when we need to uninstall the proxy and the back the become. We need to know who to do the became with."
	dict keysAndValuesDo: [:originalObject :proxy |
		"If the proxy is already a proxy it means that in this graph to swap out, there are proxies. This means that there was a shared object with another graph and such graph has already been swapped out. So we should not update the information of that proxy because otherwise we wont be able to get back the original object"
		originalObject mareaIsProxy ifFalse: [
			"It may happen that one of the original objects of the graph is not in the list of serialized objects. This is because usually, serializers like Fuel do some optimizations for certain classes and instead of traversing all its instances, they just serialize something smaller and different, like a number. An example, is the class Date. The instance variables 'start duration' are not traversed. Instead, Fuel serializes just a number that represents the Date. So, in this case, we will create a proxy for an object that it is not serialized. This is a problem and I don't really know how to solve to far. Luckily, it is not a very common case.' "
			proxy mareaSetPosition: (serializedInstances at: originalObject ifAbsent: [0]) setGraphID: graphID.].
	].

	self mareaLog: 'Proxies were updated with their correct position'.! !

Object subclass: #ObjectProxyInterceptor
	instanceVariableNames: ''
	classVariableNames: 'MutexProxy'
	poolDictionaries: ''
	category: 'Marea-Proxies'!

!ObjectProxyInterceptor class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 12/8/2011 17:11'!
initialize
	MutexProxy := Mutex new.! !

!ObjectProxyInterceptor methodsFor: 'intercepting' stamp: 'MarianoMartinezPeck 12/13/2011 15:08'!
cannotInterpret: aMessage
	|  context counter |

	"For the moment I remove the mutex because it brings more problems than the one it solves. In fact, there is some deadlock when materializing lots of classes."
"	MutexProxy critical: 
	["
	MareaLogger logger log:  'cannotInterpret:  ', aMessage selector.
	MareaLogger logger log:  'Stack:  '.
	MareaLogger logger log:  '----------------'.
		
	context := thisContext sender.
	counter := 0.
	[context isNil not and: [counter < 50]] whileTrue:  [
		MareaLogger logger log: context  method mareaPrintString.
		context := context sender.
		counter := counter + 1.
		].
	
	MareaLogger logger log:  '----------------'.
		
	^ ProxyHandler handleInterception: aMessage for: self	
"	]"

! !

ObjectProxyInterceptor subclass: #ProxyTrap
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Marea-Proxies'!

ProxyTrap subclass: #AbstractProxy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Marea-Proxies'!

!AbstractProxy class methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 12/8/2011 17:09'!
allInstances
	"Answer a collection of all current instances of the receiver."

	| all inst next |
	all := OrderedCollection new.
	inst := self someInstance.
	[inst == nil]
		whileFalse: [
		next := inst mareaNextInstance.
		inst == all ifFalse: [all add: inst].
		inst := next].
	^ all asArray! !

!AbstractProxy class methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 12/8/2011 17:09'!
allInstancesDo: aBlock 
	"Evaluate the argument, aBlock, for each of the current instances of the 
	receiver.
	
	Because aBlock might change the class of inst (for example, using become:),
	it is essential to compute next before aBlock value: inst."
	| inst next |
	inst := self someInstance.
	[inst == nil]
		whileFalse:
		[
		next := inst mareaNextInstance.
		aBlock value: inst.
		inst := next]! !

!AbstractProxy class methodsFor: 'install-uninstall' stamp: 'MarianoMartinezPeck 12/8/2011 17:09'!
mareaAllInstalledProxies
	^ self allInstances select: [:each | each mareaIsProxyInstalled ]
 
! !

!AbstractProxy class methodsFor: 'install-uninstall' stamp: 'MarianoMartinezPeck 12/8/2011 17:09'!
mareaAllInstalledProxiesCount
	^ self mareaAllInstalledProxies size
	
 
! !

!AbstractProxy class methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 12/9/2011 16:29'!
mareaIsProxy 
	^ true! !

!AbstractProxy class methodsFor: 'install-uninstall' stamp: 'MarianoMartinezPeck 12/8/2011 17:09'!
mareaUninstallIfNeededAllInstances
	self allInstancesDo: [:each | each mareaUninstallIfNeeded ]
 
! !

!AbstractProxy class methodsFor: 'install-uninstall' stamp: 'MarianoMartinezPeck 12/8/2011 17:09'!
mareaUninstallIfNeededAllInstancesWithTracing: aLogger
	| counter |
	counter := 0.
	self allInstancesDo: [:instance| 
		(counter \\ 5000) isZero ifTrue: [
			aLogger log: ''.
			aLogger log: SmalltalkImage current vmStatisticsReportString.
			aLogger log: ''.
		]. 
	counter := counter + 1.
	instance mareaUninstallIfNeeded
	].
! !

!AbstractProxy class methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 12/8/2011 17:13'!
newProxy
	| newProxy |
	newProxy := self new.
	"Just in case"
	ProxyTrap nilMethodDict.
	^ newProxy ! !

!AbstractProxy methodsFor: 'serialization' stamp: 'MarianoMartinezPeck 12/8/2011 17:09'!
asSetElement
	"Answer an object, which can be put into a Set as element , wrapped
	by one of SetElement instance, if necessary. 
	Default implementation is to answer self"
! !

!AbstractProxy methodsFor: 'serialization' stamp: 'MarianoMartinezPeck 12/8/2011 17:09'!
enclosedSetElement! !

!AbstractProxy methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 12/8/2011 17:09'!
initialize! !

!AbstractProxy methodsFor: 'serialization' stamp: 'MarianoMartinezPeck 12/8/2011 17:09'!
mareaBasicIdentityHash
	"Answer a SmallInteger whose value is related to the receiver's identity.
	This method must not be overridden, except by SmallInteger.
	Primitive. Fails if the receiver is a SmallInteger. Essential.
	See Object documentation whatIsAPrimitive.

	Do not override. Use #identityHash unless you really know what you're doing.'"

	<primitive: 75>
	self primitiveFailed! !

!AbstractProxy methodsFor: 'serialization' stamp: 'MarianoMartinezPeck 12/8/2011 17:09'!
mareaBasicName
	^ 'aProxy'! !

!AbstractProxy methodsFor: 'class membership' stamp: 'MarianoMartinezPeck 12/8/2011 17:09'!
mareaClass
	"Primitive. Answer the object which is the receiver's class. Essential. See 
	Object documentation whatIsAPrimitive."

	<primitive: 111>
	self primitiveFailed! !

!AbstractProxy methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 12/8/2011 17:31'!
mareaHandler
	^ ProxyHandler ! !

!AbstractProxy methodsFor: 'serialization' stamp: 'MarianoMartinezPeck 12/8/2011 17:09'!
mareaIdentityHash
	"Answer a SmallInteger whose value is related to the receiver's identity.
	This method must not be overridden, except by SmallInteger.
	
	Do not override."
	
	^ self mareaBasicIdentityHash bitShift: 18! !

!AbstractProxy methodsFor: 'testing' stamp: 'MarianoMartinezPeck 12/8/2011 17:09'!
mareaIsProxy
	^ true! !

!AbstractProxy methodsFor: 'testing' stamp: 'MarianoMartinezPeck 12/8/2011 17:09'!
mareaIsProxyInstalled
	^ self subclassResponsibility ! !

!AbstractProxy methodsFor: 'logging' stamp: 'MarianoMartinezPeck 12/8/2011 17:09'!
mareaLog: anObject
	MareaLogger logger log: anObject.! !

!AbstractProxy methodsFor: 'enumerating' stamp: 'MarianoMartinezPeck 12/8/2011 17:09'!
mareaNextInstance
	"Primitive. Answer the next instance after the receiver in the 
	enumeration of all instances of this class. Fails if all instances have been 
	enumerated. Essential. See Object documentation whatIsAPrimitive."

	<primitive: 78>
	^nil! !

!AbstractProxy methodsFor: 'message handling' stamp: 'MarianoMartinezPeck 12/8/2011 17:09'!
mareaPerform: selector withArguments: argArray inSuperclass: lookupClass
	"NOTE:  This is just like perform:withArguments:, except that
	the message lookup process begins, not with the receivers's class,
	but with the supplied superclass instead.  It will fail if lookupClass
	cannot be found among the receiver's superclasses.
	Primitive. Essential. See Object documentation whatIsAPrimitive."

	<primitive: 100>
	(selector isSymbol)
		ifFalse: [^ self error: 'selector argument must be a Symbol'].
	(selector numArgs = argArray size)
		ifFalse: [^ self error: 'incorrect number of arguments'].
	(self class == lookupClass or: [self class inheritsFrom: lookupClass])
		ifFalse: [^ self error: 'lookupClass is not in my inheritance chain'].
	self primitiveFailed! !

!AbstractProxy methodsFor: 'install-uninstall' stamp: 'MarianoMartinezPeck 12/8/2011 17:09'!
mareaUninstall
	^ self mareaHandler uninstallForProxy: self
! !

!AbstractProxy methodsFor: 'install-uninstall' stamp: 'MarianoMartinezPeck 12/8/2011 17:09'!
mareaUninstallIfNeeded
	^ self mareaHandler uninstallIfNeeded: self
! !

AbstractProxy subclass: #ClassProxy
	instanceVariableNames: 'superclass methodDict format proxyID'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Marea-Proxies'!

!ClassProxy methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 12/13/2011 16:35'!
initialize
	"If you change this, change also #mareaIsWellInitialized"
	superclass := ClassProxyInterceptor.
	methodDict := nil.
	format := Object format! !

!ClassProxy methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/30/2011 16:03'!
mareaGraphID
	^ proxyID bitAnd: 2r111111111111111! !

!ClassProxy methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/30/2011 16:03'!
mareaIsProxyInstalled
	^ proxyID isNil not! !

!ClassProxy methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 12/13/2011 16:35'!
mareaIsWellInitialized
	^  ((methodDict == nil) and: [ format = Object format ]) and: [ superclass == ClassProxyInterceptor ] ! !

!ClassProxy methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 12/13/2011 16:33'!
mareaMethodDict
	^ methodDict! !

!ClassProxy methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/30/2011 16:03'!
mareaPosition
	^ proxyID >> 15 
	! !

!ClassProxy methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/30/2011 16:03'!
mareaProxyID
	^ proxyID! !

!ClassProxy methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/30/2011 16:03'!
mareaProxyID: aNumber
	proxyID := aNumber! !

!ClassProxy methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/30/2011 16:03'!
mareaSetPosition: aPosition setGraphID: aGraphID
	proxyID :=  (aGraphID bitAnd: 16rFFFF) bitOr: (aPosition << 15).
! !

AbstractProxy subclass: #RegularObjectProxy
	instanceVariableNames: 'proxyID'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Marea-Proxies'!

!RegularObjectProxy methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/2/2011 15:10'!
mareaGraphID
	^ proxyID bitAnd: 2r111111111111111! !

!RegularObjectProxy methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/3/2011 10:05'!
mareaIsProxyInstalled
	^ proxyID isNil not! !

!RegularObjectProxy methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/2/2011 15:10'!
mareaPosition
	^ proxyID >> 15 
	! !

!RegularObjectProxy methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/2/2011 15:10'!
mareaProxyID
	^ proxyID! !

!RegularObjectProxy methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/3/2011 16:38'!
mareaProxyID: aNumber
	proxyID := aNumber! !

!RegularObjectProxy methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/2/2011 15:09'!
mareaSetPosition: aPosition setGraphID: aGraphID
	proxyID :=  (aGraphID bitAnd: 16rFFFF) bitOr: (aPosition << 15).
! !

!ProxyTrap class methodsFor: 'initialize' stamp: 'MarianoMartinezPeck 12/8/2011 17:10'!
initialize
	self nilMethodDict ! !

!ProxyTrap class methodsFor: 'method dictionary' stamp: 'MarianoMartinezPeck 12/8/2011 17:10'!
nilMethodDict
	methodDict := nil. ! !

Object subclass: #ProxyHandler
	instanceVariableNames: ''
	classVariableNames: 'MareaSerializer MethodsNotToIntercept'
	poolDictionaries: ''
	category: 'Marea-Proxies'!

!ProxyHandler class methodsFor: 'handle - debugging' stamp: 'MarianoMartinezPeck 10/3/2011 14:55'!
debuggingMessagesToHandle
	| dict |
	dict := Dictionary new.
	dict at: #basicInspect put:#handleBasicInspect:.
	dict at: #inspect put:#handleInspect:.
	dict at: #inspectorClass put:#handleInspectorClass:.
	dict at: #defaultLabelForInspector put:#handleDefaultLabelForInspector:.
	dict at: #printStringLimitedTo: put: #handlePrintStringLimitedTo:.
	dict at: #printString put: #handlePrintString:.
	dict at: #longPrintOn:limitedTo:indent: put: #handleLongPrintOnLimitedToIndent:.
	dict at: #printOn: put: #handlePrintOn:.
	^ dict		! !

!ProxyHandler class methodsFor: 'proxy handling' stamp: 'MarianoMartinezPeck 12/2/2011 14:00'!
defaultMethodsNotToIntercept
	| dict |
	dict := Dictionary new.	
	dict addAll: self debuggingMessagesToHandle.
	dict addAll: self methodsMessagesToHandle.
"	dict addAll: self testSupportMessagesToHandle.
	dict addAll: self classProxyMessagesToHandle."
	^ dict
	
	! !

!ProxyHandler class methodsFor: 'handle - debugging' stamp: 'MarianoMartinezPeck 10/2/2011 21:23'!
handleBasicInspect: anInterception
	"Create and schedule an Inspector in which the user can examine the 
	receiver's variables. This method should not be overriden."
	^ToolSet basicInspect: anInterception proxy! !

!ProxyHandler class methodsFor: 'handle - debugging' stamp: 'MarianoMartinezPeck 10/2/2011 21:23'!
handleDefaultLabelForInspector: anInterception
	^ 'Proxy'! !

!ProxyHandler class methodsFor: 'handle - methods' stamp: 'MarianoMartinezPeck 12/2/2011 14:01'!
handleFlushCache: anInterception
	^ anInterception target selector flushCache	 
		! !

!ProxyHandler class methodsFor: 'handle - debugging' stamp: 'MarianoMartinezPeck 10/2/2011 21:23'!
handleInspect: anInterception
	"Create and schedule an Inspector in which the user can examine the receiver's variables."
	ToolSet inspect: anInterception proxy! !

!ProxyHandler class methodsFor: 'handle - debugging' stamp: 'MarianoMartinezPeck 10/2/2011 21:23'!
handleInspectorClass: anInterception
	"Answer the class of the inspector to be used on the receiver.  Called by inspect; 
	use basicInspect to get a normal (less useful) type of inspector."

	^ Inspector! !

!ProxyHandler class methodsFor: 'proxy handling' stamp: 'MarianoMartinezPeck 12/7/2011 12:26'!
handleInterception: aMessage for: aProxy
	| answer oldObject interception |
	
	interception := Interception for: aMessage target: nil proxy: aProxy receiver: nil. 
	(self isMessageNotToIntercept: aMessage)
		ifTrue: [ ^ self manageMessageInternally: interception ]
	 	ifFalse: [ ^ self manageMessage: interception  ]
	
	
	"oldObject := self uninstallForProxy: aProxy.
	self mareaLog: 'The message will be sent to the original object'.
	answer := aMessage sendTo: oldObject.
	self mareaLog: 'The message: ', aMessage selector asString, ' was sent to the original object'.
	^ answer "
! !

!ProxyHandler class methodsFor: 'proxy handling' stamp: 'MarianoMartinezPeck 12/8/2011 23:59'!
handleInterception: aMessage for: aProxy receiver: aReceiver

	self mareaLog: 'This was a message for an instance whose class was profixied'.
	ObjectGraphSwapper new swapInGraphFor: aProxy.
	^ aReceiver perform: aMessage selector withArguments: aMessage arguments.

! !

!ProxyHandler class methodsFor: 'handle - debugging' stamp: 'MarianoMartinezPeck 10/2/2011 21:23'!
handleLongPrintOnLimitedToIndent: anInterception
	! !

!ProxyHandler class methodsFor: 'handle - methods' stamp: 'MarianoMartinezPeck 12/2/2011 15:11'!
handleMethodExecution: anInterception
	| targetCM |
	self log: 'message ', anInterception message selector, ' execution intercepted and will be forwarded'.
	targetCM := ObjectGraphSwapper new swapInGraphFor: anInterception proxy.
	^ targetCM valueWithReceiver: anInterception message arguments third arguments: anInterception message arguments second
	
! !

!ProxyHandler class methodsFor: 'handle - debugging' stamp: 'MarianoMartinezPeck 10/2/2011 21:23'!
handlePrintOn: anInterception
	anInterception message arguments first nextPutAll: 'aProxy'  ! !

!ProxyHandler class methodsFor: 'handle - debugging' stamp: 'MarianoMartinezPeck 10/2/2011 21:24'!
handlePrintString: anInterception
	^ anInterception proxy printStringLimitedTo: 50000! !

!ProxyHandler class methodsFor: 'handle - debugging' stamp: 'MarianoMartinezPeck 12/13/2011 23:54'!
handlePrintStringLimitedTo: anInterception
	| proxy |
	proxy := anInterception proxy. 
	^ 'This is the print of a proxy of class: ',  proxy mareaClass name asString, ', graphID: ', proxy mareaGraphID asString , ' and position: ', proxy mareaPosition asString. ! !

!ProxyHandler class methodsFor: 'proxy handling' stamp: 'MarianoMartinezPeck 10/2/2011 15:23'!
isMessageNotToIntercept: aMessage
	^ self methodsNotToIntercept includesKey: aMessage selector  ! !

!ProxyHandler class methodsFor: 'proxy handling' stamp: 'MarianoMartinezPeck 10/3/2011 14:48'!
manageMessage: interception
	| target |
	self mareaLog: 'The method ', interception message selector, ' will beforwarded'.
"	self mareaLog: 'messa:', interception message asString.
	self mareaLog: 'target: :', interception target.
"	 
	target := ObjectGraphSwapper new swapInGraphFor: interception proxy.
	
	^ interception message sendTo: target
	! !

!ProxyHandler class methodsFor: 'proxy handling' stamp: 'MarianoMartinezPeck 10/3/2011 10:31'!
manageMessageInternally: anInterception 
	self mareaLog: 'The method ', anInterception message selector, ' will NOT be forwarded by instead answer by the handler'.
	^ self perform: (self methodsNotToIntercept at: anInterception message selector) with: anInterception ! !

!ProxyHandler class methodsFor: 'handle - methods' stamp: 'MarianoMartinezPeck 12/2/2011 14:01'!
methodsMessagesToHandle
	| dict |
	dict := Dictionary new.
	dict at: #flushCache put: #handleFlushCache:.
	dict at: #run:with:in: put: #handleMethodExecution:.
	^ dict
! !

!ProxyHandler class methodsFor: 'proxy handling' stamp: 'MarianoMartinezPeck 12/9/2011 17:01'!
methodsNotToIntercept
	MethodsNotToIntercept isNil ifTrue: [ MethodsNotToIntercept := self defaultMethodsNotToIntercept ].
	^ MethodsNotToIntercept ! !

!ProxyHandler class methodsFor: 'install-uninstall' stamp: 'MarianoMartinezPeck 10/2/2011 15:05'!
uninstallForProxy: aProxy
	^ self uninstallForProxy: aProxy ifNotInstalled: [ ProxyIsNotInstalled signal: 'The proxy is not installed. '].! !

!ProxyHandler class methodsFor: 'install-uninstall' stamp: 'MarianoMartinezPeck 10/2/2011 15:07'!
uninstallForProxy: aProxy ifNotInstalled: errorBLock
	| oldObject originalObject |
	
	self mareaLog: 'Starting to uninstall.'.
	aProxy mareaIsProxyInstalled ifFalse: [ 
		self mareaLog: 'The proxy is not installed'.
		errorBLock value ].
	
	ObjectGraphSwapper new swapInGraphFor: aProxy.
	
	"now oldObject points to the proxy and aProxy points to the old object"
	self mareaLog: 'The Proxy for ', aProxy mareaBasicName, ' was uninstalled.'.
	^ aProxy.  
! !

!ProxyHandler class methodsFor: 'install-uninstall' stamp: 'MarianoMartinezPeck 12/8/2011 17:31'!
uninstallIfNeeded: aProxy
	^ [self uninstallForProxy: aProxy] on: ProxyIsNotInstalled do: [].! !

!ProxyHandler methodsFor: 'seeClassSide' stamp: 'MarianoMartinezPeck 10/2/2011 14:54'!
seeClassSide! !
MareaLogger initialize!
ClassProxyInterceptor initialize!
ObjectProxyInterceptor initialize!
ProxyTrap initialize!
